#include <common.h>
//#include <rbusPpOverlayReg.h>
#include <ppoverlay_reg.h>
#include <gdma_reg.h>
#include <osdovl_reg.h>
//#include <rbus/osh_reg.h>
#if 0
#include <rbusColor_osd_shpnrReg.h>
#endif
#include <rtk_gdma_driver.h>
#include <rtk_gdma_scale_coef.h>
#include <panel_config_parameter.h>
#include <panel.h>
#include <asm/arch/io.h>
#include <sys_reg_reg.h>
#include <pll_reg_reg.h>
#include <pll27x_reg_reg.h>
#include <stb_reg.h>
#include <system.h>

#include <rtbdinfo.h>

int gdma_nr_devs = GDMA_NR_DEVS;
gdma_dev *gdma_devices = 0;          /* allocated in gdma_init_module */
short GDMA_coef_4t8p_ratio_swap_    [GDMA_NUM_COEFF_RATIOS][4][4] ;
#if defined(CONFIG_SYS_PANEL_PARAMETER)
extern struct _PANEL_CONFIG_PARAMETER  default_panel_parameter;
#endif

/* gdma workqueue  */
struct gdma_receive_work sGdmaReceiveWork[GDMA_MAX_PIC_Q_SIZE];

#ifdef _TEST_CODE_GDMA_
//#include "gdma_rtk_logo.h"
void osd_test(void) {
#if 1
	unsigned int *fillcolor = NULL;
	int iloop = 0, jloop = 0;

	fillcolor = 0xC800000;// malloc_noncache(1280*720*4);
	if(fillcolor==NULL)
	{
		printf("malloc fail\n");
		return;
	}
	memset(fillcolor, 0xff, 1280*720*4);
	printf("fillcolor=0x%x\n",fillcolor);

	for(iloop=0; iloop< 1280*720; iloop++)
	{
		if(iloop<((1280*720)/2))
		{
			jloop = iloop%1280;
			if(jloop<300)
				fillcolor[iloop] = 0xff0000ff;//Red//RGBA
			else if((jloop>=300)&&(jloop<600))
				fillcolor[iloop] = 0xff00ff00;//Green
			else if((jloop>=600)&&(jloop<1280))
				fillcolor[iloop] = 0xffff0000;//Blue
		}
		else
		{
			jloop = iloop%1280;
			if(jloop<500)
				fillcolor[iloop] = 0xffff00ff;//Red
			else if((jloop>=500)&&(jloop<1000))
				fillcolor[iloop] = 0xffffffff;//white
			else if((jloop>=1000)&&(jloop<1280))
				fillcolor[iloop] = 0xff00ffff;//yellow
		}
	}
#endif

	gdma_dev *gdma = &gdma_devices[0];
	GDMA_PICTURE_OBJECT *picObj;
	PICTURE_LAYERS_OBJECT pic_layer;

	memset(&pic_layer, 0, sizeof(PICTURE_LAYERS_OBJECT));
	picObj = &pic_layer.layer[0].normal[0];

	pic_layer.layer_num = 1;
	pic_layer.layer[0].normal_num = 1;
	pic_layer.layer[0].onlineOrder = C0;

	picObj->src_type = SRC_NORMAL;
	//picObj->format = VO_OSD_COLOR_FORMAT_ARGB8888_LITTLE;
	picObj->format = VO_OSD_COLOR_FORMAT_RGBA8888;
	//picObj->fbdc_format;
	picObj->context = 0;
	picObj->key_en = 0;
	picObj->colorkey = -1;
	picObj->alpha = 0xff;
	picObj->x = 0;
	picObj->y = 0;
	//picObj->width = 260;
	//picObj->height = 200;
	picObj->width = 1280;
	picObj->height = 720;
	//picObj->address = virt_to_phys(gdma_rtk_logo_260x200);
	picObj->address = virt_to_phys(fillcolor);
	picObj->pitch = picObj->width * 4;
	picObj->seg_addr[0] = picObj->address;
	picObj->seg_addr[1] = picObj->address;
	//picObj->picLayout;
	picObj->compressed = 0;
	//picObj->wbType;
	//picObj->seg_num;
	//picObj->current_comp_idx;
	picObj->plane = VO_GRAPHIC_OSD1;
	picObj->dst_x = 0;
	picObj->dst_y = 0;
	picObj->dst_width = gdma->osdPlane[0].OSD_canvas.dispWin.width;
	picObj->dst_height = gdma->osdPlane[0].OSD_canvas.dispWin.height;
	picObj->layer_used = 1;
	picObj->plane_ar.plane_alpha_a = 0xff;
	picObj->plane_ar.plane_alpha_r = 0xff;
	picObj->plane_gb.plane_alpha_g = 0xff;
	picObj->plane_gb.plane_alpha_b = 0xff;
	picObj->clear_x.value = 0;
	picObj->clear_y.value = 0;
	picObj->show = 1;
	//picObj->paletteformat;
	//picObj->paletteIndex;
	//picObj->rgb_order;
	picObj->syncInfo.syncstamp = 0;
	picObj->scale_factor = 1;

	GDMA_ReceivePicture(&pic_layer);
	picObj->plane = VO_GRAPHIC_OSD2;
	GDMA_ReceivePicture(&pic_layer);
	picObj->plane = VO_GRAPHIC_OSD3;
	GDMA_ReceivePicture(&pic_layer);
}
#endif



void getDispSize(VO_RECTANGLE *disp_rec)
{
	/* gdma_dev *gdma = &gdma_devices[0]; */

	/*display_timing_ctrl2_RBUS display_timing_ctrl2;*/
	ppoverlay_memcdtg_dh_den_start_end_RBUS memcdtg_dh_den_start_end;
	ppoverlay_memcdtg_dv_den_start_end_RBUS memcdtg_dv_den_start_end;
	unsigned int active_h = 0;
	unsigned int active_v = 0;

#if defined(CONFIG_SYS_PANEL_PARAMETER)
	//PANEL_CONFIG_PARAMETER *panel_parameter = (PANEL_CONFIG_PARAMETER *)&default_panel_parameter;
#endif

	/*display_timing_ctrl2.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL2_reg);*/
	memcdtg_dh_den_start_end.regValue = rtd_inl(PPOVERLAY_memcdtg_DH_DEN_Start_End_reg);
	memcdtg_dv_den_start_end.regValue = rtd_inl(PPOVERLAY_memcdtg_DV_DEN_Start_End_reg);
	memset(disp_rec, 0, sizeof(VO_RECTANGLE));


	active_h = memcdtg_dh_den_start_end.memcdtg_dh_den_end-memcdtg_dh_den_start_end.memcdtg_dh_den_sta;
	active_v = memcdtg_dv_den_start_end.memcdtg_dv_den_end-memcdtg_dv_den_start_end.memcdtg_dv_den_sta;

	if ((active_h > 3800) && (active_h <= 3850)) {
		/* 4k */
		active_h = 3840;
	} else if ((active_h > 1900) && (active_h <= 1930)) {

		/* 2k */
		active_h = 1920;
	} else {
		DBG_PRINT("ERR:%s--%d\n", __FUNCTION__, __LINE__);
	}


	if ((active_v > 2100) && (active_v <= 2170)) {
		/* 2K */
		active_v = 2160;
	} else if ((active_v > 1000) && (active_v <= 1090)) {
		/* 1K */
		active_v = 1080;
	} else {
		DBG_PRINT("ERR:%s--%d\n", __FUNCTION__, __LINE__);
	}


#if defined(CONFIG_SYS_PANEL_PARAMETER)
	if(active_v == 0 || active_h == 0) {
		printf("[GDMA] OSD dtg get 0..\n");
		active_v = default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS;
		active_h = default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS;
	}
#endif

#if 0
	if (gdma->f_mixer_after_dfrc) {
		disp_rec->width = active_h;
		disp_rec->height = active_v;
	} else {
		/* 0: Hx2, Vx2 (1->2, 1->4) */
		/* 1: Vx2(1->2, 2->4) */
		/* 2: Hx2(1->2, 2->4) */
		/* 3: SR_bypass(1->1, 2->2, 4->4) */

		switch (display_timing_ctrl2.sr_mode) {
		case 0:
			disp_rec->width = active_h>>1;
			disp_rec->height = active_v>>1;
			break;
		case 1:
			disp_rec->width = active_h;
			disp_rec->height = active_v>>1;
			break;

		case 2:
			disp_rec->width = active_h>>1;
			disp_rec->height = active_v;
			break;
		case 3:
		default:
			disp_rec->width = active_h;
			disp_rec->height = active_v;
			break;

		}
	}
#else
	disp_rec->width = active_h;
	disp_rec->height = active_v;
#endif
	printf("[GDMA] OSD size[%d,%d]\n",disp_rec->width,disp_rec->height);
	return;

}

int drv_scaleup(uint8_t enable, GDMA_DISPLAY_PLANE disPlane)
{
	gdma_dev *gdma = &gdma_devices[0];
	gdma_line_buffer_end_RBUS line_buffer_end_reg;
	unsigned int offset = 0 ;
	GDMA_PIC_DATA *curPic;
	GDMA_REG_CONTENT *pReg = NULL;

	curPic = gdma->pic[disPlane] + gdma->curPic[disPlane];
	pReg = &curPic->reg_content;

	*(unsigned int *)&line_buffer_end_reg = rtd_inl(GDMA_line_buffer_end_reg);
	line_buffer_end_reg.regValue = rtd_inl(GDMA_line_buffer_end_reg);
	if (line_buffer_end_reg.osdsr1_switch_to == disPlane)
		offset = 0x0;
	else if (line_buffer_end_reg.osdsr2_switch_to == disPlane)
		offset = 0x80;
	else {
		DBG_SR_PRINT("%s, No match with OSDSRx_switch_to to OSD%d !! \n", __FUNCTION__, disPlane) ;
		return GDMA_SUCCESS;
	}


	DBG_SR_PRINT("%s, line_buffer_end_reg=0x%x\n", __FUNCTION__, line_buffer_end_reg.regValue) ;

	if (enable) {
		rtd_outl(OSD_SR_OSD_SR_1_Scaleup_Ctrl0_reg+offset, pReg->osd_sr_scaleup_ctrl0_reg.regValue);
		rtd_outl(OSD_SR_OSD_SR_1_Scaleup_Ctrl1_reg+offset, pReg->osd_sr_scaleup_ctrl1_reg.regValue);
		rtd_outl(OSD_SR_OSD_SR_1_V_Location_Ctrl_reg+offset, pReg->osd_sr_v_location_ctrl_reg.regValue);
		rtd_outl(OSD_SR_OSD_SR_1_H_Location_Ctrl_reg+offset, pReg->osd_sr_h_location_ctrl_reg.regValue);
#if 0
		if ((pReg->osd_sr_scaleup_ctrl1_reg.h_zoom_en != 0) || (pReg->osd_sr_scaleup_ctrl0_reg.v_zoom_en != 0))
			fwif_color_set_scaleosd_sharpness_driver(0, 1);
		else
			fwif_color_set_scaleosd_sharpness_driver(0, 0);
#endif
	} else {
		rtd_outl(OSD_SR_OSD_SR_1_Scaleup_Ctrl0_reg+offset, pReg->osd_sr_scaleup_ctrl0_reg.regValue);
		rtd_outl(OSD_SR_OSD_SR_1_Scaleup_Ctrl1_reg+offset, pReg->osd_sr_scaleup_ctrl1_reg.regValue);
		rtd_outl(OSD_SR_OSD_SR_1_V_Location_Ctrl_reg+offset, pReg->osd_sr_v_location_ctrl_reg.regValue);
		rtd_outl(OSD_SR_OSD_SR_1_H_Location_Ctrl_reg+offset, pReg->osd_sr_h_location_ctrl_reg.regValue);
	}


	return GDMA_SUCCESS;
}

int drv_PreScale(uint8_t enable, VO_RECTANGLE srcWin, VO_RECTANGLE dispWin,
						GDMA_DISPLAY_PLANE disPlane, struct gdma_receive_work *ptr_work)
{
	gdma_dev *gdma = &gdma_devices[0];
	gdma_line_buffer_end_RBUS line_buffer_end_reg;
	osd_sr_osd_sr_1_scaleup_ctrl0_RBUS osd_sr_scaleup_ctrl0_reg;
	osd_sr_osd_sr_1_scaleup_ctrl1_RBUS osd_sr_scaleup_ctrl1_reg;
	osd_sr_osd_sr_1_h_location_ctrl_RBUS osd_sr_h_location_ctrl_reg;
	osd_sr_osd_sr_1_v_location_ctrl_RBUS osd_sr_v_location_ctrl_reg;
	unsigned int ver_factor = 0;
	unsigned int hor_factor = 0;
#ifdef OSD_SR_DEBUG
	unsigned int offset = 0;
#endif
	GDMA_PIC_DATA *curPic;
	GDMA_REG_CONTENT *pReg = NULL;

	curPic = gdma->pic[disPlane] + ptr_work->picQwr;
	pReg = &curPic->reg_content;

	*(unsigned int *)&line_buffer_end_reg = rtd_inl(GDMA_line_buffer_end_reg);
	line_buffer_end_reg.regValue = rtd_inl(GDMA_line_buffer_end_reg);

#ifdef OSD_SR_DEBUG
	if (line_buffer_end_reg.osdsr1_switch_to == disPlane)
		offset = 0x0;
	else if (line_buffer_end_reg.osdsr2_switch_to == disPlane)
		offset = 0x80;
#endif

	DBG_SR_PRINT("%s, line_buffer_end_reg=0x%x\n", __FUNCTION__, line_buffer_end_reg.regValue) ;

	if (enable) {
		osd_sr_scaleup_ctrl0_reg.v_zoom_en = 0;
		osd_sr_scaleup_ctrl0_reg.ver_ini = 0;
		osd_sr_scaleup_ctrl0_reg.ver_factor = 0;
		pReg->osd_sr_scaleup_ctrl0_reg.regValue = osd_sr_scaleup_ctrl0_reg.regValue;

		osd_sr_scaleup_ctrl1_reg.h_zoom_en = 0;
		osd_sr_scaleup_ctrl1_reg.hor_ini = 0;
		osd_sr_scaleup_ctrl1_reg.hor_factor = 0;
		pReg->osd_sr_scaleup_ctrl1_reg.regValue = osd_sr_scaleup_ctrl1_reg.regValue;

		osd_sr_v_location_ctrl_reg.osd_v_sta = dispWin.y;
		osd_sr_v_location_ctrl_reg.osd_height = dispWin.height;
		pReg->osd_sr_v_location_ctrl_reg.regValue = osd_sr_v_location_ctrl_reg.regValue;

		osd_sr_h_location_ctrl_reg.osd_h_sta = dispWin.x;
		osd_sr_h_location_ctrl_reg.osd_width = dispWin.width;
		pReg->osd_sr_h_location_ctrl_reg.regValue = osd_sr_h_location_ctrl_reg.regValue;

		/*
		OSD_H_STA+OSD_WIDTH , OSD_V_STA+OSD_HEIGHT < video range
		input_width >=16
		*/
		if (srcWin.width == 0 || srcWin.height == 0 || dispWin.width == 0 || dispWin.height == 0) {
			printf("GDMA division by :srcWin.width = %d,srcWin.height=%d\n", srcWin.width, srcWin.height) ;
			printf("GDMA division by :dispWin.width = %d,dispWin.height=%d\n", dispWin.width, dispWin.height) ;
		}
		DBG_SR_PRINT("%s:srcWin.width = %d,srcWin.height=%d\n", __FUNCTION__, srcWin.width, srcWin.height) ;
		DBG_SR_PRINT("%s:dispWin.width = %d,dispWin.height=%d\n", __FUNCTION__, dispWin.width, dispWin.height) ;

		/* online mode : h_front_porch >= 16, v_back_porch >= 16 */
		if ((((dispWin.x+dispWin.width) > (gdma->dispWin[disPlane].width+1)) ||
			 ((dispWin.y+dispWin.height) > (gdma->dispWin[disPlane].height+1)))) {
			/* Under flow */

			printf("%s:dispWin.x = %d,dispWin.y=%d\n", __FUNCTION__, dispWin.x, dispWin.y) ;
			printf("%s:dispWin.width = %d,dispWin.height=%d\n", __FUNCTION__, dispWin.width, dispWin.height) ;
			printf("%s:gdma->dispWin[%d].width = %d,gdma->dispWin[%d].height=%d\n", __FUNCTION__,
				   disPlane, gdma->dispWin[disPlane].width, disPlane, gdma->dispWin[disPlane].height) ;

			printf("%s:data underflow\n", __FUNCTION__) ;
			return -1;
		} else if ((srcWin.width != dispWin.width) && ((srcWin.width < 16) || (srcWin.width%2 == 1))) {
			printf("%s:srcWin.width = %d [>=16 and even]\n", __FUNCTION__, srcWin.width) ;
			return -1;
		} else {
			hor_factor = (srcWin.width<<20)/dispWin.width;
			ver_factor = (srcWin.height<<20)/dispWin.height;
			DBG_SR_PRINT("%s hor_factor=0x%x,ver_factor=0x%x\n", __FUNCTION__, hor_factor, ver_factor) ;

			if ((srcWin.height < dispWin.height) && (ver_factor)) { /*  ?? no scaling down? */
				osd_sr_scaleup_ctrl0_reg.v_zoom_en = 1;
				osd_sr_scaleup_ctrl0_reg.ver_ini = srcWin.y;
				osd_sr_scaleup_ctrl0_reg.ver_factor = ver_factor;

#if 0			/* OSR_SR auto mode */
				if (srcWin.width <= 2560)
					osd_sr_scaleup_ctrl0_reg.ver_tap_num = 1;
				else if (srcWin.width <= 5120)
					osd_sr_scaleup_ctrl0_reg.ver_tap_num = 2;
				if (osd_sr_scaleup_ctrl0_reg.v_zoom_en == 0)
					osd_sr_scaleup_ctrl0_reg.ver_tap_num = 3;
#endif
				pReg->osd_sr_scaleup_ctrl0_reg.regValue = osd_sr_scaleup_ctrl0_reg.regValue;

				pReg->osd_sr_scaleup_ctrl0_reg.regValue = osd_sr_scaleup_ctrl0_reg.regValue;
			}

			if ((srcWin.width < dispWin.width) && (hor_factor)) { /*  ?? no scaling down? */
				osd_sr_scaleup_ctrl1_reg.h_zoom_en = 1;
				osd_sr_scaleup_ctrl1_reg.hor_ini = srcWin.x;
				osd_sr_scaleup_ctrl1_reg.hor_factor = hor_factor;
				pReg->osd_sr_scaleup_ctrl1_reg.regValue = osd_sr_scaleup_ctrl1_reg.regValue;
			}
#if 0
			/* if ((osd_sr_scaleup_ctrl1_reg.h_zoom_en!=0)||(osd_sr_scaleup_ctrl0_reg.v_zoom_en!=0)) */
			/* 	fwif_color_set_scaleosd_sharpness_driver(0, 1); */
			/* else */
			/*     fwif_color_set_scaleosd_sharpness_driver(0, 0); */
#endif
		}
	} else {
			osd_sr_scaleup_ctrl0_reg.v_zoom_en = 0;
			osd_sr_scaleup_ctrl0_reg.ver_ini = 0x00;
			osd_sr_scaleup_ctrl0_reg.ver_factor = 0;
			pReg->osd_sr_scaleup_ctrl0_reg.regValue = osd_sr_scaleup_ctrl0_reg.regValue;

			osd_sr_scaleup_ctrl1_reg.h_zoom_en = 0;
			osd_sr_scaleup_ctrl1_reg.hor_ini = 0;
			osd_sr_scaleup_ctrl1_reg.hor_factor = 0;
			pReg->osd_sr_scaleup_ctrl1_reg.regValue = osd_sr_scaleup_ctrl1_reg.regValue;
			DBG_SR_PRINT("OSD_SR_X_Scaleup_Ctrl0_reg[0x%x] 0x%x\n", OSD_SR_1_Scaleup_Ctrl0_reg+offset, pReg->osd_sr_scaleup_ctrl0_reg.regValue) ;
			DBG_SR_PRINT("OSD_SR_X_Scaleup_Ctrl1_reg[0x%x] 0x%x\n", OSD_SR_1_Scaleup_Ctrl1_reg+offset, pReg->osd_sr_scaleup_ctrl1_reg.regValue) ;

			osd_sr_v_location_ctrl_reg.osd_v_sta = dispWin.y;
			osd_sr_v_location_ctrl_reg.osd_height = dispWin.height;
			pReg->osd_sr_v_location_ctrl_reg.regValue = osd_sr_v_location_ctrl_reg.regValue;

			osd_sr_h_location_ctrl_reg.osd_h_sta = dispWin.x;
			osd_sr_h_location_ctrl_reg.osd_width = dispWin.width;
			pReg->osd_sr_h_location_ctrl_reg.regValue = osd_sr_h_location_ctrl_reg.regValue;
		}


	return GDMA_SUCCESS;
}



/* only for 4 taps */
void GDMA_SetVideoScalingCoeffs (unsigned short *coeff, int delta_phase, int init_phase, int taps)
{
	int i;

	if (ABS(delta_phase - 0x4000) < 0x20 && init_phase == 0) {
		memset (coeff, 0, taps << 3);
		for (i = 1; i <= 4; i++)
			coeff[(taps << 2) - i] = 0x1000;
	} else if (taps == 2) { /*	not used cause vout 2 tap coeff is set once in init & SE use 16 phase */
		for (i = 0; i < 8; i++)
			coeff[i] = GDMA_coef_2t8p_swap[i^1];
	} else {
		/* find the best coefficient set based on scaling ratio */
		if (delta_phase >= 0x4000) { /* down-scaling */
			for (i = 1; i < GDMA_NUM_COEFF_RATIOS - 1; i++) {
				/* VscaleRatio is incrementing, we find the first one that's bigger than or equal to delta
				instead of min ads diff. This way it will round up to lower pass filter to avoid alias */
				if (GDMA_ScaleRatio[i] >= delta_phase)
					break;
			}
		} else /* upscaling */
			i = 0;

		memcpy (coeff, GDMA_coef_4t8p_ratio_swap_[i][0], taps << 3);
	}
}


#if 0
/*
*   sel: 0: return BusH clock
*        1: return Ddomain clock
*/
int GDMA_BusH_DClk_info(int sel)
{
	unsigned int ret_clk = 27;
	unsigned int value_m = 0, value_n = 0, value_o = 0, value_f = 0;
	unsigned int tmp = 0;
	unsigned int pll_pdiv=1;
	unsigned int pll_div=1;

	if (sel == 0) {
		/*for K4 PLL
		BUSH = 27/(PDIV+1)*(Ncode+3+Fcode/2048)/(DIV+1)
		*/

		if ((rtd_inl(STB_ST_BUSCLK_reg) & STB_ST_BUSCLK_bus_clksel_mask) == 0) {
			tmp = rtd_inl(PLL_REG_SYS_PLL_BUSH1_reg);
			pll_pdiv = PLL_REG_SYS_PLL_BUSH1_get_pllbus_pdiv_h(tmp);
			pll_div = PLL_REG_SYS_PLL_BUSH1_get_pllbus_div_h(tmp);

			tmp = rtd_inl(PLL_REG_SYS_PLL_BUSH2_reg);
			value_f = PLL_REG_SYS_PLL_BUSH2_get_pllbus_fcode_h(tmp);
			value_n = PLL_REG_SYS_PLL_BUSH2_get_pllbus_ncode_h(tmp);

			/*baker, for more precise, add multiple 2 at clk and
			 divide 2 in the end*/

			ret_clk = 27*2/(pll_pdiv+1)*(value_n + 3 + (value_f >> 11))/(pll_div+1)/2;
		} else {
			ret_clk = 27;
		}
		DBG_PRINT("BusH clock: %d Mhz \n", ret_clk);
	} else if (sel == 1) {
		tmp = rtd_inl(PLL27X_REG_SYS_PLL_DISP1_reg);
		value_m = PLL27X_REG_SYS_PLL_DISP1_get_dpll_m(tmp);
		value_n = PLL27X_REG_SYS_PLL_DISP1_get_dpll_n(tmp);
		tmp = rtd_inl(PLL27X_REG_PLL_SSC0_reg);
		value_f = PLL27X_REG_PLL_SSC0_fcode_t_ssc(tmp);
		tmp = rtd_inl(PLL27X_REG_SYS_PLL_DISP3_reg);
		value_o = PLL27X_REG_SYS_PLL_DISP3_get_dpll_o(tmp);

		ret_clk = 27*(value_m+3+(value_f >> 11))/(value_n+2)/(1<<value_o);
		DBG_PRINT("D-domain clock: %d Mhz \n", ret_clk);
	}

	return ret_clk;
}
#endif

int GDMA_init_module(unsigned int cmdbaddr)
{
	int result, j, k;
	gdma_dev *gdma = NULL;
	gdma_line_buffer_sta_RBUS line_buffer_sta_reg;
	gdma_line_buffer_size_RBUS line_buffer_size_reg;
	gdma_line_buffer_end_RBUS line_buffer_end_reg;
	osdovl_mixer_ctrl2_RBUS mixer_ctrl2;
	osdovl_mixer_layer_sel_RBUS osdovl_mixer_layer_sel_reg;
	osdovl_mixer_b1_RBUS mixer_bx_reg;
	osdovl_osd_db_ctrl_RBUS osd_db_ctrl_reg;
	ppoverlay_memcdtg_dh_den_start_end_RBUS dtg_h;
	ppoverlay_memcdtg_dv_den_start_end_RBUS dtg_v;
	unsigned int prog_done_mask = GDMA_CTRL_osd3_prog_done(1) | GDMA_CTRL_osd2_prog_done(1)|
		GDMA_CTRL_osd1_prog_done(1);
	unsigned int onlineProgDone = GDMA_CTRL_write_data(1);

#if defined(CONFIG_SYS_PANEL_PARAMETER)
	PANEL_CONFIG_PARAMETER *panel_parameter = (PANEL_CONFIG_PARAMETER *)&default_panel_parameter;
	DBG_PRINT("[GDMA]panel_parameter->iCONFIG_PANEL_TYPE=%d\n", panel_parameter->iCONFIG_PANEL_TYPE);
	DBG_PRINT("[GDMA]panel_parameter=%s\n", panel_parameter->sPanelName);
#endif

	DBG_PRINT("\n[GDMA] %s\n",__func__);
	dtg_h.regValue = rtd_inl(PPOVERLAY_memcdtg_DH_DEN_Start_End_reg);
	dtg_v.regValue = rtd_inl(PPOVERLAY_memcdtg_DV_DEN_Start_End_reg);
#if defined(KERNEL_RESERVE_FOR_GDMA_ADDR)
	gdma_devices = (gdma_dev *)KERNEL_RESERVE_FOR_GDMA_ADDR;
#else

	if(cmdbaddr == 0) {
#ifdef CONFIG_NONCACHE_ALLOCATION
		gdma_devices = (gdma_dev *)malloc_noncache(gdma_nr_devs * sizeof(gdma_dev));
#else
		gdma_devices = (gdma_dev *)malloc(gdma_nr_devs * sizeof(gdma_dev));
#endif
		printf("GDMA: init without addr, malloc =%08x\n",(unsigned int)(gdma_devices));
	}else{
		gdma_devices = (gdma_dev *)cmdbaddr;
		printf("GDMA: init with addr =%08x\n",cmdbaddr);
	}
#endif

	if (!(gdma_devices)) {
		printf("\n[GDMA] %s malloc_noncache fail.\n",__func__);
		return result;
	}
	memset(gdma_devices, 0, gdma_nr_devs * sizeof(gdma_dev));
	gdma = &gdma_devices[0];

#if defined(CONFIG_SYS_PANEL_PARAMETER)
	gdma->iCONFIG_PANEL_TYPE = panel_parameter->iCONFIG_PANEL_TYPE;
	gdma->iCONFIG_PANEL_CUSTOM_INDEX = panel_parameter->iCONFIG_PANEL_CUSTOM_INDEX;
	DBG_PRINT("[GDMA]gdma->iCONFIG_PANEL_TYPE=%d\n", gdma->iCONFIG_PANEL_TYPE);
	DBG_PRINT("[GDMA]gdma->iCONFIG_PANEL_CUSTOM_INDEX=%d\n", gdma->iCONFIG_PANEL_CUSTOM_INDEX);
#endif

	gdma->f_palette_update = false;

	/* OSD plane */
	for (k = 0; k < GDMA_MAX_NUM_OSD_WIN; k++) {
		for (j = 0; j < MAX_OSD_NUM; j++) {
			gdma->osdPlane[j].OSDwin[k].ctrl.id     = k;
			gdma->osdPlane[j].OSDwin[k].ctrl.previd =
				gdma->osdPlane[j].OSDwin[k].ctrl.nextid = 0xff;
		}
	}

	for (k = 0; k < MAX_OSD_NUM; k++) {
		gdma->osdPlane[k].OSD_canvas.srcWin.x  =
			gdma->osdPlane[k].OSD_canvas.srcWin.y  = 0;
		gdma->osdPlane[k].OSD_canvas.srcWin.width  = 1280;
		gdma->osdPlane[k].OSD_canvas.srcWin.height = 720;

		gdma->osdPlane[k].OSD_canvas.dispWin.width = dtg_h.memcdtg_dh_den_end-dtg_h.memcdtg_dh_den_sta;
		gdma->osdPlane[k].OSD_canvas.dispWin.height = dtg_v.memcdtg_dv_den_end-dtg_v.memcdtg_dv_den_sta;
	}

	/* Yvonne_Sirius+ */
	for (k = 0; k < GDMA_PLANE_MAXNUM; k++) {
		gdma->dispWin[k].width = dtg_h.memcdtg_dh_den_end-dtg_h.memcdtg_dh_den_sta;
		gdma->dispWin[k].height = dtg_v.memcdtg_dv_den_end-dtg_v.memcdtg_dv_den_sta;
	}
	/* Yvonne_Sirius- */

	gdma->GDMA_osd.wi_endian    = 0;/* Yvonne todo */
	gdma->GDMA_osd.osd      = 1;
	gdma->GDMA_osd.write_data      = 1;
	gdma->GDMA_osd_ctrl.write_data = 1;

	rtd_outl(GDMA_OSD1_reg, *((u32 *)&gdma->GDMA_osd));
	rtd_outl(GDMA_OSD2_reg, *((u32 *)&gdma->GDMA_osd));
	rtd_outl(GDMA_OSD3_reg, *((u32 *)&gdma->GDMA_osd));

	/* OSD_SR switch */
	//line_buffer_end_reg.regValue = rtd_inl(GDMA_line_buffer_end_reg);
	line_buffer_end_reg.regValue = 0;
	line_buffer_end_reg.osdsr1_switch_to = GDMA_PLANE_OSD1;
	line_buffer_end_reg.osdsr2_switch_to = GDMA_PLANE_OSD3;
	rtd_outl(GDMA_line_buffer_end_reg, line_buffer_end_reg.regValue);

	/* line buffer setting */
	line_buffer_sta_reg.regValue = rtd_inl(GDMA_line_buffer_sta_reg);
	line_buffer_size_reg.regValue = rtd_inl(GDMA_line_buffer_size_reg);

	line_buffer_sta_reg.l4 = 0;
	line_buffer_sta_reg.l5 = 2;
	line_buffer_size_reg.l4 = 1;
	line_buffer_size_reg.l5 = 1;
	rtd_outl(GDMA_line_buffer_sta_reg, line_buffer_sta_reg.regValue);
	rtd_outl(GDMA_line_buffer_size_reg, line_buffer_size_reg.regValue);

	onlineProgDone |= GDMA_CTRL_osd1_prog_done(1);
	onlineProgDone |= GDMA_CTRL_osd2_prog_done(1);
	onlineProgDone |= GDMA_CTRL_osd3_prog_done(1);
	/* OSD programming done */
	rtd_outl(GDMA_CTRL_reg, onlineProgDone);
	printf("%s, 1st onlineProgDone=0x%x \n", __FUNCTION__, onlineProgDone);

	/* onlineProgDone reset to default */
	onlineProgDone = GDMA_CTRL_write_data(1);

	/* wait prog done */
	while ((rtd_inl(GDMA_CTRL_reg)&prog_done_mask) != 0) ;
	printf("%s, 1st passed \n", __FUNCTION__);

	/*
	*	initialization flow
	*	line buffer setting + OSD_SR switch + go_middle_blend could be set together, then write all online path programming done
	* 	After above mention, we could change online or offline OSD HW path now
	*/


	/* enable OSD1/OSD2/OSD3 on Mixer */
	mixer_ctrl2.regValue = rtd_inl(OSDOVL_Mixer_CTRL2_reg);
	mixer_ctrl2.video_src_sel = 0;
	mixer_ctrl2.mixero1_en    = 1;
	mixer_ctrl2.mixero2_en    = 0;
	mixer_ctrl2.mixero3_en    = 0;
	mixer_ctrl2.video_src_sel = 0;
	mixer_ctrl2.mixer_en      = 1;
	rtd_outl(OSDOVL_Mixer_CTRL2_reg, mixer_ctrl2.regValue);
#if 0

	dma_bl_2_RBUS dma_bl_2_reg;
	/* wdma_bl set to 'd80 by HW RD suggestion */
	dma_bl_2_reg.regValue = rtd_inl(GDMA_DMA_BL_2_reg);
	dma_bl_2_reg.wdma_bl = 80;
	rtd_outl(GDMA_DMA_BL_2_reg, dma_bl_2_reg.regValue);
#endif

	/* mixer layer sel: video keep at c5 place */
	osdovl_mixer_layer_sel_reg.regValue = rtd_inl(OSDOVL_Mixer_layer_sel_reg);
	osdovl_mixer_layer_sel_reg.c0_sel = GDMA_PLANE_OSD1;
	osdovl_mixer_layer_sel_reg.c1_sel = GDMA_PLANE_OSD2;
	osdovl_mixer_layer_sel_reg.c2_sel = GDMA_PLANE_OSD3;
	rtd_outl(OSDOVL_Mixer_layer_sel_reg, osdovl_mixer_layer_sel_reg.regValue);

	/* mixer blend factor & mid-blend blend factor & offline blend factor */
	mixer_bx_reg.k1 = 0xc;
	mixer_bx_reg.k2 = 0x3;
	mixer_bx_reg.k3 = 0x2d;
	mixer_bx_reg.k4 = 0x3;
	rtd_outl(OSDOVL_Mixer_b1_reg, mixer_bx_reg.regValue);
	rtd_outl(OSDOVL_Mixer_b2_reg, mixer_bx_reg.regValue);
	rtd_outl(OSDOVL_Mixer_b3_reg, mixer_bx_reg.regValue);

	/* mixer double buffer */
	osd_db_ctrl_reg.regValue = rtd_inl(OSDOVL_OSD_Db_Ctrl_reg);
	osd_db_ctrl_reg.db_read = 1;	/* 1: see rbus setting temporarily, 0: see HW latch now  */
	osd_db_ctrl_reg.db_en = 1;
	osd_db_ctrl_reg.db_load = 1;
	rtd_outl(OSDOVL_OSD_Db_Ctrl_reg, osd_db_ctrl_reg.regValue);


	onlineProgDone |= GDMA_CTRL_osd1_prog_done(1);
	onlineProgDone |= GDMA_CTRL_osd2_prog_done(1);
	onlineProgDone |= GDMA_CTRL_osd3_prog_done(1);

	/* OSD programming done */
	rtd_outl(GDMA_CTRL_reg, onlineProgDone);
	printf("%s, 2nd onlineProgDone=0x%x \n", __FUNCTION__, onlineProgDone);

		/* wait prog done */
	while ((rtd_inl(GDMA_CTRL_reg)&prog_done_mask) != 0) ;
	printf("%s, 2nd passed \n", __FUNCTION__);

	DBG_PRINT("%s, %d, MIXER             0x%x\n", __FUNCTION__, __LINE__, rtd_inl(OSDOVL_Mixer_CTRL2_reg));
	DBG_PRINT("[GDMA] Panel Width=%d, Height=%d \n", gdma->dispWin[0].width, gdma->dispWin[0].height);

	/* clear blend_setting_conflict */
	rtd_outl(GDMA_blend_setting_conflict_reg, 0);

	gdma->plane = GDMA_PLANE_NONE;
	gdma->ctrl.displayEachPic = 1;
	gdma->ctrl.OSD1onTop      = 0;

#ifdef _TEST_CODE_GDMA_
	osd_test();
#endif
#if 0
#if defined(CONFIG_SYS_PANEL_PARAMETER)
	if (panel_parameter->iVFLIP)	{
		/*  SFG_CTRL_0 */
		rtd_outl(SFG_SFG_CTRL_0_reg, rtd_inl(SFG_SFG_CTRL_0_reg) | SFG_SFG_CTRL_0_h_flip_en(1));
		GDMA_ConfigVFlip(1);
	}
#endif
#endif
	printf("GDMA module_init finish\n");
	return 0;
}





/** @brief Set OSD HW registers according to parameter disPlane which indicate OSD number
 *  @param disPlane HW OSD number (GDMA_DISPLAY_PLANE includes GDMA_PLANE_OSD1 & GDMA_PLANE_OSD2)
 *  @return None
 */
static void GDMA_OSDReg_Set(GDMA_DISPLAY_PLANE disPlane)
{
	gdma_dev *gdma = &gdma_devices[0];
	GDMA_PIC_DATA *curPic;
	unsigned int offset = 0;
	osdovl_mixer_layer_sel_RBUS osdovl_mixer_layer_sel_reg;
	//line_buffer_end_RBUS line_buffer_end_reg;
	GDMA_REG_CONTENT *pReg = NULL;
	unsigned int cx_sel_old = 0, cx_sel_new = 0;

	curPic = gdma->pic[disPlane] + gdma->curPic[disPlane];
	pReg = &curPic->reg_content;

	DBG_PRINT("%s line=%d disPlane=%d, workqueueIdx=%d \n", __FUNCTION__, __LINE__, disPlane, curPic->workqueueIdx);
	DBG_PRINT("%s gdma->curPic[%d]=%d, curPic->onlineOrder=%d\n", __FUNCTION__, disPlane, gdma->curPic[disPlane], curPic->onlineOrder);


	if (disPlane == GDMA_PLANE_OSD2)
		offset = 0x100;
	else if (disPlane == GDMA_PLANE_OSD3)
		offset = 0x200;


	/*  set clear region */
	rtd_outl(GDMA_OSD1_CLEAR1_reg+offset, pReg->osd_clear1_reg.regValue);
	rtd_outl(GDMA_OSD1_CLEAR2_reg+offset, pReg->osd_clear2_reg.regValue);
	rtd_outl(GDMA_OSD1_reg+offset, pReg->osd_reg.regValue);

	rtd_outl(GDMA_OSD1_CTRL_reg+offset, ~1);
	rtd_outl(GDMA_OSD1_CTRL_reg+offset, pReg->osd_ctrl_reg.regValue);

	rtd_outl(GDMA_OSD1_WI_reg+offset, pReg->osd_wi_reg.regValue);
	rtd_outl(GDMA_OSD1_WI_3D_reg+offset, pReg->osd_wi_3d_reg.regValue);
	rtd_outl(GDMA_OSD1_SIZE_reg+offset, pReg->osd_size_reg.regValue);

	DBG_PRINT("%s GDMA_OSD%d_CLEAR1_reg=0x%x \n", __FUNCTION__, disPlane, pReg->osd_clear1_reg.regValue);
	DBG_PRINT("%s GDMA_OSD%d_CLEAR2_reg=0x%x \n", __FUNCTION__, disPlane, pReg->osd_clear2_reg.regValue);
	DBG_PRINT("%s GDMA_OSD%d_reg=0x%x \n", __FUNCTION__, disPlane, pReg->osd_reg.regValue);
	DBG_PRINT("%s GDMA_OSD%d_CTRL_reg=0x%x \n", __FUNCTION__, disPlane, pReg->osd_ctrl_reg.regValue);
	DBG_PRINT("%s GDMA_OSD%d_WI_reg=0x%x \n", __FUNCTION__, disPlane, pReg->osd_wi_reg.regValue);
	DBG_PRINT("%s GDMA_OSD%d_WI_3D_reg=0x%x \n", __FUNCTION__, disPlane, pReg->osd_wi_3d_reg.regValue);
	DBG_PRINT("%s GDMA_OSD%d_SIZE_reg=0x%x \n", __FUNCTION__, disPlane, pReg->osd_size_reg.regValue);

	/*  TODO:: call osd_sr  */
	drv_scaleup(1, disPlane);


	/* enable bundle & change OSDSRx_switch_to */
	rtd_outl(GDMA_line_buffer_end_reg, pReg->lb_end_reg.regValue);

	/*  TODO: Mixer : online blend order & plane alpha
	*	because k blend-factor setting, mixer layer order will reverse
	*/
	osdovl_mixer_layer_sel_reg.regValue = rtd_inl(OSDOVL_Mixer_layer_sel_reg);
	if (curPic->onlineOrder == C0) {
		cx_sel_old = osdovl_mixer_layer_sel_reg.c0_sel;
		cx_sel_new = osdovl_mixer_layer_sel_reg.c0_sel = pReg->osdovl_mixer_layer_sel_reg.c0_sel;

		if (pReg->osdovl_mixer_layer_sel_reg.c0_plane_alpha_en != osdovl_mixer_layer_sel_reg.c0_plane_alpha_en)
			osdovl_mixer_layer_sel_reg.c0_plane_alpha_en = pReg->osdovl_mixer_layer_sel_reg.c0_plane_alpha_en;

		rtd_outl(OSDOVL_Mixer_c0_plane_alpha1_reg, pReg->mixer_c0_plane_alpha1_reg.regValue);
		rtd_outl(OSDOVL_Mixer_c0_plane_alpha2_reg, pReg->mixer_c0_plane_alpha2_reg.regValue);
	} else if (curPic->onlineOrder == C1) {
		cx_sel_old = osdovl_mixer_layer_sel_reg.c1_sel;
		cx_sel_new = osdovl_mixer_layer_sel_reg.c1_sel = pReg->osdovl_mixer_layer_sel_reg.c1_sel;

		if (pReg->osdovl_mixer_layer_sel_reg.c1_plane_alpha_en != osdovl_mixer_layer_sel_reg.c1_plane_alpha_en)
			osdovl_mixer_layer_sel_reg.c1_plane_alpha_en = pReg->osdovl_mixer_layer_sel_reg.c1_plane_alpha_en;

		rtd_outl(OSDOVL_Mixer_c1_plane_alpha1_reg, pReg->mixer_c1_plane_alpha1_reg.regValue);
		rtd_outl(OSDOVL_Mixer_c1_plane_alpha2_reg, pReg->mixer_c1_plane_alpha2_reg.regValue);
	} else if (curPic->onlineOrder == C2) {
		cx_sel_old = osdovl_mixer_layer_sel_reg.c2_sel;
		cx_sel_new = osdovl_mixer_layer_sel_reg.c2_sel = pReg->osdovl_mixer_layer_sel_reg.c2_sel;

		if (pReg->osdovl_mixer_layer_sel_reg.c2_plane_alpha_en != osdovl_mixer_layer_sel_reg.c2_plane_alpha_en)
			osdovl_mixer_layer_sel_reg.c2_plane_alpha_en = pReg->osdovl_mixer_layer_sel_reg.c2_plane_alpha_en;

		rtd_outl(OSDOVL_Mixer_c2_plane_alpha1_reg, pReg->mixer_c2_plane_alpha1_reg.regValue);
		rtd_outl(OSDOVL_Mixer_c2_plane_alpha2_reg, pReg->mixer_c2_plane_alpha2_reg.regValue);
	} else if (curPic->onlineOrder == C3) {
		cx_sel_old = osdovl_mixer_layer_sel_reg.c3_sel;
		cx_sel_new = osdovl_mixer_layer_sel_reg.c3_sel = pReg->osdovl_mixer_layer_sel_reg.c3_sel;

		if (pReg->osdovl_mixer_layer_sel_reg.c3_plane_alpha_en != osdovl_mixer_layer_sel_reg.c3_plane_alpha_en)
			osdovl_mixer_layer_sel_reg.c3_plane_alpha_en = pReg->osdovl_mixer_layer_sel_reg.c3_plane_alpha_en;

		rtd_outl(OSDOVL_Mixer_c3_plane_alpha1_reg, pReg->mixer_c3_plane_alpha1_reg.regValue);
		rtd_outl(OSDOVL_Mixer_c3_plane_alpha2_reg, pReg->mixer_c3_plane_alpha2_reg.regValue);
	}



	/* conflict protect */
	if (osdovl_mixer_layer_sel_reg.c0_sel == cx_sel_new && curPic->onlineOrder != C0)
		osdovl_mixer_layer_sel_reg.c0_sel = cx_sel_old;
	else if (osdovl_mixer_layer_sel_reg.c1_sel == cx_sel_new && curPic->onlineOrder != C1)
		osdovl_mixer_layer_sel_reg.c1_sel = cx_sel_old;
	else if (osdovl_mixer_layer_sel_reg.c2_sel == cx_sel_new && curPic->onlineOrder != C2)
		osdovl_mixer_layer_sel_reg.c2_sel = cx_sel_old;
	else if (osdovl_mixer_layer_sel_reg.c3_sel == cx_sel_new && curPic->onlineOrder != C3)
		osdovl_mixer_layer_sel_reg.c3_sel = cx_sel_old;

	rtd_outl(OSDOVL_Mixer_layer_sel_reg, osdovl_mixer_layer_sel_reg.regValue);
	DBG_PRINT("%s, GDMA_line_buffer_end_reg=0x%x, OSDOVL_Mixer_layer_sel_reg=0x%x \n", __FUNCTION__, rtd_inl(GDMA_line_buffer_end_reg), osdovl_mixer_layer_sel_reg.regValue);

}

/** @brief main dequeue function that prepare the register value and store in GDMA_REG_CONTENT
 *  @param disPlane HW OSD number (GDMA_DISPLAY_PLANE includes GDMA_PLANE_OSD1/2/3/4/5)
 *  @return None
 */
static void GDMA_PreOSDReg_Set(struct gdma_receive_work *ptr_work)
{
	VO_RECTANGLE srcWin;
	VO_RECTANGLE dispWin;
	int canvasW, canvasH;/*, hout, vout;*/
	GDMA_WIN *win = NULL, *win_3d = NULL;
	gdma_dev *gdma = &gdma_devices[0];
	GDMA_PIC_DATA *curPic;
	GDMA_REG_CONTENT *pReg = NULL;
	GDMA_DISPLAY_PLANE disPlane = ptr_work->disPlane;
	int rotateBit = gdma->ctrl.enableVFlip;

	memset(&srcWin, 0, sizeof(VO_RECTANGLE));
	memset(&dispWin, 0, sizeof(VO_RECTANGLE));

	curPic = gdma->pic[disPlane] + ptr_work->picQwr;
	pReg = &curPic->reg_content;

	DBG_PRINT("%s line=%d disPlane=%d ptr_work->picQwr=%d \n", __FUNCTION__, __LINE__, disPlane, ptr_work->picQwr);

	win = &curPic->OSDwin;
	win_3d = &curPic->OSDwin3D;

	if (win->used) {
		srcWin.x = win->winXY.x;
		srcWin.y = win->winXY.y;

		srcWin.width = win->winWH.width;
		srcWin.height = win->winWH.height;

		dispWin.x = win->dst_x;
		dispWin.y = win->dst_y;

		if (win->dst_width != 0 && win->dst_height != 0) {
			dispWin.width = win->dst_width;
			dispWin.height = win->dst_height;
		} else {
			dispWin.width = gdma->dispWin[disPlane].width;
			dispWin.height = gdma->dispWin[disPlane].height;
		}

		/* default OSDSRx_switch_to with online path */
		pReg->lb_end_reg.osdsr1_switch_to = GDMA_PLANE_OSD1;
		pReg->lb_end_reg.osdsr2_switch_to = GDMA_PLANE_OSD3;

		/* whether non-compressed or normal or FBDC layer, canvas always is source size
		*  this is different between mac3 and magellan2, mac3's compressed image that canvas is panel size
		*/
		canvasW = srcWin.width;
		canvasH = srcWin.height;

#if 0
		hout = win->dst_width ? win->dst_width : (gdma->dispWin[disPlane].width);
		vout = win->dst_height ? win->dst_height : (gdma->dispWin[disPlane].height);

		/*  3D PR Mode, output height scaling down 1/2 */
		if (gdma->ctrl.enable3D && gdma->ctrl.enable3D_PR_SGMode)
			vout = vout / 2;
#endif


		/*  set clear region */
		if (curPic->clear_x.value != 0 || curPic->clear_y.value != 0) {
			pReg->osd_clear1_reg.regValue = curPic->clear_x.value;
			pReg->osd_clear2_reg.regValue = curPic->clear_y.value;
			pReg->osd_reg.regValue = GDMA_OSD1_clear_region_en(1) | GDMA_OSD1_write_data(1);
		} else {
			pReg->osd_reg.regValue = GDMA_OSD1_clear_region_en(1) | GDMA_OSD1_write_data(0);
		}

		if (gdma->ctrl.osdfirstEn[disPlane] == 0) {

			pReg->osd_ctrl_reg.regValue = GDMA_OSD1_CTRL_write_data(1) | GDMA_OSD1_CTRL_osd1_en(curPic->show) | GDMA_OSD1_CTRL_rotate(rotateBit) | GDMA_OSD1_CTRL_d3_mode(gdma->ctrl.enable3D);

			gdma->ctrl.osdEn[disPlane] = 1;
			gdma->ctrl.osdfirstEn[disPlane] = 1;
			DBG_PRINT("%s win=0x%x, phy=0x%x\n", __FUNCTION__, (unsigned int)win, virt_to_phys(win));
		} else {
			/*  if osdEn changes to 0, driver will force curPic->show to zero and disable OSD */
			if (gdma->ctrl.osdEn[disPlane] == 0)
				curPic->show = 0;

			pReg->osd_ctrl_reg.regValue = GDMA_OSD1_CTRL_write_data(1) | GDMA_OSD1_CTRL_osd1_en(curPic->show) | GDMA_OSD1_CTRL_rotate(rotateBit);

			/*  3D SG mode use d3_mode (frame sequence) */
			if (gdma->ctrl.enable3D && (gdma->ctrl.enable3D_PR_SGMode == 0))
				pReg->osd_ctrl_reg.regValue |= GDMA_OSD1_CTRL_d3_mode(gdma->ctrl.enable3D);
		}

		/*
		if (gdma->f_box_mode && gdma->box_dst_height == VIDEO_USERDEFINED)
		   rtd_outl(OSD_XY_Addr, GDMA_OSD3_XY_x(dispWin.x) | GDMA_OSD3_XY_y(dispWin.y));
		else
			rtd_outl(OSD_XY_Addr, 0);
			rtd_outl(OSD_XY_Addr, GDMA_OSD3_XY_x(dispWin.x) | GDMA_OSD3_XY_y(dispWin.y));
		*/

		DBG_PRINT("curPic->show=%d, gdma->ctrl.osdEn[%d]=%d \n", curPic->show, disPlane, gdma->ctrl.osdEn[disPlane]);
		DBG_PRINT("osd%d  win=0x%x, top=0x%x  \n", disPlane, (unsigned int)win, win->top_addr);
		DBG_PRINT("input src[x,y,w,h]= [%d,%d,%d,%d] \n", win->winXY.x, win->winXY.y, canvasW, canvasH);
		DBG_PRINT("output[x,y,w,h]= [%d,%d,%d,%d] \n", win->dst_x, win->dst_y, hout, vout);
		DBG_PRINT("%s, plane_alpha_r=0x%x, plane_alpha_a=0x%x \n", __FUNCTION__, curPic->plane_ar.plane_alpha_r, curPic->plane_ar.plane_alpha_a);
		DBG_PRINT("%s, plane_alpha_g=0x%x, plane_alpha_b=0x%x \n", __FUNCTION__, curPic->plane_gb.plane_alpha_g, curPic->plane_gb.plane_alpha_b);
		pReg->osd_wi_reg.regValue = GDMA_OSD1_WI_addr (virt_to_phys(win));
		pReg->osd_wi_3d_reg.regValue = GDMA_OSD1_WI_3D_addr (virt_to_phys(win_3d));
		pReg->osd_size_reg.regValue = GDMA_OSD1_SIZE_w(canvasW) | GDMA_OSD1_SIZE_h(canvasH);

		/*  TODO:: call osd_sr */
		drv_PreScale(1, srcWin, dispWin, disPlane, ptr_work);

		/*  TODO: Mixer : online blend order & plane alpha */
		if (curPic->onlineOrder == C0) {
			pReg->osdovl_mixer_layer_sel_reg.c0_sel = disPlane;

			if ((curPic->plane_ar.plane_alpha_r != 0xff) || (curPic->plane_ar.plane_alpha_a != 0xff))
				pReg->osdovl_mixer_layer_sel_reg.c0_plane_alpha_en = 1;

			if ((curPic->plane_gb.plane_alpha_g != 0xff) || (curPic->plane_gb.plane_alpha_b != 0xff))
				pReg->osdovl_mixer_layer_sel_reg.c0_plane_alpha_en = 1;

			pReg->mixer_c0_plane_alpha1_reg.regValue = curPic->plane_ar.value;
			pReg->mixer_c0_plane_alpha2_reg.regValue = curPic->plane_gb.value;
		} else if (curPic->onlineOrder == C1) {
			pReg->osdovl_mixer_layer_sel_reg.c1_sel = disPlane;

			if ((curPic->plane_ar.plane_alpha_r != 0xff) || (curPic->plane_ar.plane_alpha_a != 0xff))
				pReg->osdovl_mixer_layer_sel_reg.c1_plane_alpha_en = 1;

			if ((curPic->plane_gb.plane_alpha_g != 0xff) || (curPic->plane_gb.plane_alpha_b != 0xff))
				pReg->osdovl_mixer_layer_sel_reg.c1_plane_alpha_en = 1;

			pReg->mixer_c1_plane_alpha1_reg.regValue = curPic->plane_ar.value;
			pReg->mixer_c1_plane_alpha2_reg.regValue = curPic->plane_gb.value;
		} else if (curPic->onlineOrder == C2) {
			pReg->osdovl_mixer_layer_sel_reg.c2_sel = disPlane;

			if ((curPic->plane_ar.plane_alpha_r != 0xff) || (curPic->plane_ar.plane_alpha_a != 0xff))
				pReg->osdovl_mixer_layer_sel_reg.c2_plane_alpha_en = 1;

			if ((curPic->plane_gb.plane_alpha_g != 0xff) || (curPic->plane_gb.plane_alpha_b != 0xff))
				pReg->osdovl_mixer_layer_sel_reg.c2_plane_alpha_en = 1;

			pReg->mixer_c2_plane_alpha1_reg.regValue = curPic->plane_ar.value;
			pReg->mixer_c2_plane_alpha2_reg.regValue = curPic->plane_gb.value;
		} else if (curPic->onlineOrder == C3) {
			pReg->osdovl_mixer_layer_sel_reg.c3_sel = disPlane;

			if ((curPic->plane_ar.plane_alpha_r != 0xff) || (curPic->plane_ar.plane_alpha_a != 0xff))
				pReg->osdovl_mixer_layer_sel_reg.c3_plane_alpha_en = 1;

			if ((curPic->plane_gb.plane_alpha_g != 0xff) || (curPic->plane_gb.plane_alpha_b != 0xff))
				pReg->osdovl_mixer_layer_sel_reg.c3_plane_alpha_en = 1;

			pReg->mixer_c3_plane_alpha1_reg.regValue = curPic->plane_ar.value;
			pReg->mixer_c3_plane_alpha2_reg.regValue = curPic->plane_gb.value;
		}
		/*  register value was ready */
		curPic->workqueueDone = 1;

	} else
		printf("%s, win->used is NOT one, something wrong \n", __FUNCTION__);

	dsb();
	dsb();
}


int GDMA_Update (gdma_dev *gdma, int inISR)
{
	volatile int Qend, loop = 0;
	volatile GDMA_PIC_DATA *curPic;
	volatile int disPlane, disPlane_tmp, cnt = 0, curPicIdx = 0;
	volatile int QueueFlag[GDMA_PLANE_MAXNUM] = {0};	/*  1: indicate this queue has picture to show */
	volatile unsigned int updatedOSDx = 0;				/* actual updated OSD number */
	volatile static int osdSyncStamp[GDMA_PLANE_MAXNUM] = {0};	/*  keep the setting which picture has syncstamp */
	//volatile static int osdSyncStampTimeout[GDMA_PLANE_MAXNUM] = {0};
	//volatile int osdSyncStampNum[GDMA_PLANE_MAXNUM] = {0};  /*  remember syncstamp driver searched before */
	volatile osdovl_osd_db_ctrl_RBUS osd_db_ctrl_reg;
	volatile int onlinePlane[GDMA_PLANE_MAXNUM] = {GDMA_PLANE_OSD1, GDMA_PLANE_OSD2, GDMA_PLANE_OSD3};
	volatile int onlineMaxNum = MAX_OSD_NUM, onlineIdx = 0;

	volatile unsigned int prog_done_mask = GDMA_CTRL_osd3_prog_done(1) | GDMA_CTRL_osd2_prog_done(1)|
		GDMA_CTRL_osd1_prog_done(1);
	volatile unsigned int onlineProgDone = GDMA_CTRL_write_data(1);
	/* fox modify for use cookie to sync GDMA */
	//static unsigned int cookie_flag = 0;


	/* search all updated picture of osd plane  */
	for (onlineIdx = 0; onlineIdx < onlineMaxNum; onlineIdx++) {
		disPlane = onlinePlane[onlineIdx];

#ifdef TRIPLE_BUFFER_SEMAPHORE
		if ((gdma->picQwr[disPlane] > gdma->curPic[disPlane])  && (gdma->picQwr[disPlane] - gdma->curPic[disPlane]) > 2)
			DBG_PRINT("GDMA line=%d : r %d,w %d c %d \n", __LINE__, gdma->picQrd[disPlane], gdma->picQwr[disPlane], gdma->curPic[disPlane]);
		else {
			if ((gdma->picQwr[disPlane] < gdma->curPic[disPlane]) && ((gdma->picQwr[disPlane]+GDMA_MAX_PIC_Q_SIZE) >= gdma->curPic[disPlane])  && ((gdma->picQwr[disPlane]+GDMA_MAX_PIC_Q_SIZE) - gdma->curPic[disPlane]) > 2)
				DBG_PRINT("GDMA line=%d : r %d,w %d c %d \n", __LINE__, gdma->picQrd[disPlane], gdma->picQwr[disPlane], gdma->curPic[disPlane]);
		}
#else
		if ((gdma->picQwr[disPlane] > gdma->curPic[disPlane])  && (gdma->picQwr[disPlane] - gdma->curPic[disPlane]) >= 2)
			DBG_PRINT("GDMA line=%d : r %d,w %d c %d \n", __LINE__, gdma->picQrd[disPlane], gdma->picQwr[disPlane], gdma->curPic[disPlane]);
		else {
			if ((gdma->picQwr[disPlane] < gdma->curPic[disPlane]) && ((gdma->picQwr[disPlane]+GDMA_MAX_PIC_Q_SIZE) >= gdma->curPic[disPlane])  && ((gdma->picQwr[disPlane]+GDMA_MAX_PIC_Q_SIZE) - gdma->curPic[disPlane]) >= 2)
				DBG_PRINT("GDMA line=%d : r %d,w %d c %d \n", __LINE__, gdma->picQrd[disPlane], gdma->picQwr[disPlane], gdma->curPic[disPlane]);
		}
#endif

		Qend = ((gdma->curPic[disPlane] + GDMA_MAX_PIC_Q_SIZE - 2) & (GDMA_MAX_PIC_Q_SIZE - 1));
		if (gdma->picQrd[disPlane] != gdma->curPic[disPlane]
			&& gdma->picQrd[disPlane] != Qend) {
			/* GDMA_ReleaseBuffers  (gdma, gdma->picQrd[disPlane] + 1, Qend, disPlane); */
			gdma->picCount[disPlane]--;
			gdma->picQrd[disPlane] = Qend;
		}

		/* check next picture */
		if (inISR) {
			if (!gdma->ctrl.sync[disPlane]) {

				if ((gdma->picQrd[disPlane] != gdma->picQwr[disPlane]) && (gdma->picQwr[disPlane] >= 1)) {

					curPicIdx = (gdma->picQrd[disPlane] + 1) & (GDMA_MAX_PIC_Q_SIZE - 1);
					curPic = gdma->pic[disPlane] + curPicIdx;
					if (curPic->workqueueDone == 1)    /*  register value was ready */
						gdma->curPic[disPlane] = curPicIdx;
					else
						continue;
					/* gdma->curPic[disPlane] = (gdma->picQrd[disPlane] + 1) & (GDMA_MAX_PIC_Q_SIZE - 1); */
					gdma->ctrl.sync[disPlane] = 1;
					QueueFlag[disPlane] = 1;
					DBG_PRINT("%s: OSD[%d]Sync ......r %d, w %d\n", __FUNCTION__, disPlane, gdma->picQrd[disPlane], gdma->picQwr[disPlane]);

#ifndef TRIPLE_BUFFER_SEMAPHORE
					/* force reset prog done register for next new picture */
					rtd_outl(GDMA_CTRL_reg, rtd_inl(GDMA_CTRL_reg)&~GDMA_CTRL_write_data_mask);
					DBG_PRINT("%s, GDMA_CTRL_reg=0x%x\n", __FUNCTION__, rtd_inl(GDMA_CTRL_reg));
#endif
				} else {
					/* Warning("%s: OSD[%d] has no picture\n", __FUNCTION__, disPlane); */
					continue;
				}
			} else {
				curPic = gdma->pic[disPlane] + gdma->curPic[disPlane];
				curPic->repeatCnt++;

				if (gdma->curPic[disPlane] != gdma->picQwr[disPlane]) { /* select next picture to display */
					/*  keep the syncstamp OSD waiting for another OSD which has the same syncstamp */
					if (osdSyncStamp[disPlane] != 1) {
						curPicIdx = gdma->ctrl.displayEachPic ? ((gdma->curPic[disPlane] + 1) & (GDMA_MAX_PIC_Q_SIZE - 1)) : gdma->picQwr[disPlane];
						/* gdma->curPic[disPlane] = gdma->ctrl.displayEachPic ? ((gdma->curPic[disPlane] + 1) & (GDMA_MAX_PIC_Q_SIZE - 1)) : gdma->picQwr[disPlane]; */

						curPic = gdma->pic[disPlane] + curPicIdx;
						if (curPic->workqueueDone == 1) {    /*  register value was ready */
#ifdef TRIPLE_BUFFER_SEMAPHORE
							if ((rtd_inl(GDMA_CTRL_reg)&prog_done_mask) != 0) {
								printf("!_GDMA Not Ready for Next Picture, disPlane=%d, GDMA_CTRL_reg=0x%x \n", disPlane, rtd_inl(GDMA_CTRL_reg));
								return GDMA_FAIL;
							}
#else
							/* force reset prog done register for next new picture */
							rtd_outl(GDMA_CTRL_reg, rtd_inl(GDMA_CTRL_reg)&~GDMA_CTRL_write_data_mask);
							DBG_PRINT("%s, GDMA_CTRL_reg=0x%x\n", __FUNCTION__, rtd_inl(GDMA_CTRL_reg));
#endif
							gdma->curPic[disPlane] = curPicIdx;
						} else
							continue;
					}
					QueueFlag[disPlane] = 1;
					DBG_PRINT("%s: disPlane=%d, next pic c %d, w %d\n", __FUNCTION__, disPlane, gdma->curPic[disPlane], gdma->picQwr[disPlane]);
				} else {
#ifdef GDMA_REPEAT_LOG
					static int prepic;
					if (prepic == gdma->curPic[disPlane]) {
						Warning("%d(%d)\n", gdma->curPic[disPlane], curPic->repeatCnt);
					} else {
						DBG_PRINT("%d(%d)\n", gdma->curPic[disPlane], curPic->repeatCnt);
					}
					prepic = gdma->curPic[disPlane];
#endif

					/*  if osdSyncStamp has picture to sync another picture QueueFlag rises */
					if (osdSyncStamp[disPlane] == 1) {
						QueueFlag[disPlane] = 1;
						DBG_PRINT("%s, check syncstamp osdSyncStamp[%d]=%d \n", __FUNCTION__, disPlane, osdSyncStamp[disPlane]);
					}
				}
			}

			/*  check Queueflag if picture wants to show */
			cnt += QueueFlag[disPlane];
			/*  check syncstamp OSD */
			curPic = gdma->pic[disPlane] + gdma->curPic[disPlane];
			if (curPic->syncInfo.syncstamp != 0 && QueueFlag[disPlane] == 1) {
				osdSyncStamp[disPlane] = 1;
				DBG_PRINT("%s, syncstamp=%lld, ", __FUNCTION__, curPic->syncInfo.syncstamp);
			}
		}
	}


	onlineMaxNum = 0;
	/* only check updated OSD HW */
	if (QueueFlag[GDMA_PLANE_OSD1] == 1) {
		onlinePlane[onlineMaxNum++] = GDMA_PLANE_OSD1;
		onlineProgDone |= GDMA_CTRL_osd1_prog_done(1);
	}
	if (QueueFlag[GDMA_PLANE_OSD2] == 1) {
		onlinePlane[onlineMaxNum++] = GDMA_PLANE_OSD2;
		onlineProgDone |= GDMA_CTRL_osd2_prog_done(1);
	}
	if (QueueFlag[GDMA_PLANE_OSD3] == 1) {
		onlinePlane[onlineMaxNum++] = GDMA_PLANE_OSD3;
		onlineProgDone |= GDMA_CTRL_osd3_prog_done(1);
	}

	if (inISR) {
		if (cnt == 0)
			return GDMA_SUCCESS;		/*  means no picture to show */
		else {
			DBG_PRINT("%s, how many OSD config at the same time, cnt=%d \n", __FUNCTION__, cnt);
		}
	} else {
		/*  force display and clear syncstamp */
		for (onlineIdx = 0; onlineIdx < onlineMaxNum; onlineIdx++) {
			disPlane = onlinePlane[onlineIdx];

			if (gdma->ctrl.sync[disPlane])
				QueueFlag[disPlane] = 1;
			osdSyncStamp[disPlane] = 0;
		}
	}



	/* update picture info to register */
	for (onlineIdx = cnt = 0; onlineIdx < onlineMaxNum; onlineIdx++) {
		disPlane = onlinePlane[onlineIdx];

		if (gdma->ctrl.sync[disPlane] && (QueueFlag[disPlane] == 1)) {

			curPic = gdma->pic[disPlane] + gdma->curPic[disPlane];
			DBG_PRINT("%s, OSD[%d] c ptr = %d \n", __FUNCTION__, disPlane, gdma->curPic[disPlane]);

			{	/* Normal case for OSD display */
				/*  call GDMA HW setting */
				GDMA_OSDReg_Set(disPlane);
				for (loop = 0; loop < onlineMaxNum; loop++) {
					disPlane_tmp = onlinePlane[loop];
					if (QueueFlag[disPlane_tmp] == 1 && (disPlane_tmp != disPlane) && osdSyncStamp[disPlane_tmp] == 0) {
						GDMA_OSDReg_Set(disPlane_tmp);
					}
				}
			}

			/*  TODO: record the actual updated OSD number */
			for (loop = 0; loop < onlineMaxNum; loop++) {
				disPlane_tmp = onlinePlane[loop];

				if (QueueFlag[disPlane_tmp] == 1 && osdSyncStamp[disPlane_tmp] == 0) {
					if (disPlane_tmp == GDMA_PLANE_OSD1)
						updatedOSDx |= GDMA_CTRL_osd1_prog_done(1);
					else if (disPlane_tmp == GDMA_PLANE_OSD2)
						updatedOSDx |= GDMA_CTRL_osd2_prog_done(1);
					else if (disPlane_tmp == GDMA_PLANE_OSD3)
						updatedOSDx |= GDMA_CTRL_osd3_prog_done(1);

					/* clear queue flag */
					QueueFlag[disPlane_tmp] = 0;

					cnt++;
				}
			}

			osd_db_ctrl_reg.regValue = rtd_inl(OSDOVL_OSD_Db_Ctrl_reg);
			osd_db_ctrl_reg.db_load = 1;

			/*
			*	check layers status to enable mid-blend
			*/
			//GDMA_MidBlendSet(cnt, updatedOSDx);

			/** line buffer calculation
			*   line buffer calculation should be done before writing programming done
			*	due to dynamic line buffer setting, progrmming done will apply with all online path
			*/
			//GDMA_LineBufferCal();


			onlineProgDone = GDMA_CTRL_write_data(1);
			/*  only check real online OSD HW */
				onlineProgDone |= GDMA_CTRL_osd1_prog_done(1);
				onlineProgDone |= GDMA_CTRL_osd2_prog_done(1);
				onlineProgDone |= GDMA_CTRL_osd3_prog_done(1);


			/* osd_other_prog_done needs to program with online osd prog done */
			DBG_PRINT("%s, updatedOSDx = 0x%x \n", __FUNCTION__, updatedOSDx);
			DBG_PRINT("%s, w onlineProgDone = 0x%x \n", __FUNCTION__, onlineProgDone);
			DBG_PRINT("%s, w osd_db_ctrl = 0x%x \n", __FUNCTION__, osd_db_ctrl_reg.regValue);
			rtd_outl(OSDOVL_OSD_Db_Ctrl_reg, osd_db_ctrl_reg.regValue); /*  mixer apply */
			rtd_outl(GDMA_CTRL_reg, onlineProgDone);  /*  gdma & sr programming done */
			DBG_PRINT("%s, r rtd_inl(%x)=0x%x\n", __FUNCTION__, GDMA_CTRL_reg, rtd_inl(GDMA_CTRL_reg));

#if 0
			if ((curPic->cookie != 0) && (cookie_flag != 0) && (gdma->GDMA_CookieCallBack)) {
				/*if (curPic->cookie != 0) {*/
					gdma->GDMA_CookieCallBack (0, curPic->cookie) ;
					curPic->cookie = 0;
				/*}*/
			}
			cookie_flag = 1;		/* delay one frame when really change picture, driver will call the callback */
#endif
			/* End - fox modify for use cookie to sync GDMA */

		}

	}

	return GDMA_SUCCESS;
}


int GDMA_ConfigVFlip (bool enable)
{
	gdma_dev *gdma = &gdma_devices[0];
	int linecnt_start, linecnt_end = 0;
	//struct timespec ts_start, ts_end;
	//unsigned long ts_diff;  /*  ms unit */
	unsigned int onlineProgDone = GDMA_CTRL_write_data(1);

	unsigned int prog_done_mask = GDMA_CTRL_osd3_prog_done(1) | GDMA_CTRL_osd2_prog_done(1)|
		GDMA_CTRL_osd1_prog_done(1);
	int delaycnt = 0;

	//getnstimeofday(&ts_start);
	linecnt_start = (rtd_inl(PPOVERLAY_new_meas0_linecnt_real_reg)&0x1FFF);
	DBG_PRINT("%s, linecnt_start = 0x%x \n", __FUNCTION__, linecnt_start);

		rtd_outl(GDMA_OSD1_CTRL_reg, ~1);
		onlineProgDone |= GDMA_CTRL_osd1_prog_done(1);
		rtd_outl(GDMA_OSD2_CTRL_reg, ~1);
		onlineProgDone |= GDMA_CTRL_osd2_prog_done(1);
		rtd_outl(GDMA_OSD3_CTRL_reg, ~1);
		onlineProgDone |= GDMA_CTRL_osd3_prog_done(1);
	rtd_outl(GDMA_CTRL_reg, GDMA_CTRL_write_data(1) | onlineProgDone);

	while (rtd_inl(GDMA_CTRL_reg) & prog_done_mask) {
		rtd_outl(GDMA_OSD1_CTRL_reg, GDMA_OSD1_CTRL_write_data(enable) | GDMA_OSD1_CTRL_rotate (1));
		rtd_outl(GDMA_OSD2_CTRL_reg, GDMA_OSD2_CTRL_write_data(enable) | GDMA_OSD2_CTRL_rotate (1));
		rtd_outl(GDMA_OSD3_CTRL_reg, GDMA_OSD3_CTRL_write_data(enable) | GDMA_OSD3_CTRL_rotate (1));
		gdma->ctrl.enableVFlip = enable;

		mdelay(5);
		//getnstimeofday(&ts_end);
		//ts_diff = (ts_end.tv_nsec - ts_start.tv_nsec) / 1000;
		if (delaycnt++ >= 4) {  // over 20 ms
			linecnt_end = (rtd_inl(PPOVERLAY_new_meas0_linecnt_real_reg)&0x1FFF);
			DBG_PRINT("%s, linecnt_end = 0x%x \n", __FUNCTION__, linecnt_end);
			if (linecnt_start == linecnt_end)	/*	no sync signal by DTG measure */
				break;
		}
	}
	return GDMA_SUCCESS;
}




/** @brief receive the picture, then send to pic ring-queue and workqueue
 *  @param data the pointer to layer information which want to show
 *  @return GDMA_SUCCESS
 */
int GDMA_ReceivePicture (PICTURE_LAYERS_OBJECT *data)
{
	gdma_dev *gdma = &gdma_devices[0];
	GDMA_PIC_DATA *pic = NULL;
	GDMA_WIN *win = NULL, *win3D = NULL;
	COMPOSE_PICTURE_OBJECT *com_picObj = NULL;
	int idx, ilayer, emptyIdx = 0, idxQwr = 0;
	GDMA_PICTURE_OBJECT *picObj = NULL;
	GDMA_DISPLAY_PLANE disPlane = VO_GRAPHIC_OSD1;
	VO_RECTANGLE disp_res;
	//int onlinePlane[GDMA_PLANE_MAXNUM], onlineMaxNum = 0;

	/*	DTG timing maybe changed at run-time, so always read DTG timing to decide the panel resolution */
	getDispSize(&disp_res);
	gdma->dispWin[0].width = disp_res.width;
	gdma->dispWin[0].height = disp_res.height;
	DBG_PRINT("%s Panel [%d,%d]\n", __FUNCTION__, disp_res.width, disp_res.height);
	DBG_PRINT("%s data->layer_num=%d\n", __FUNCTION__, data->layer_num);

	/*	take care DISPD_GDMA_CLK_SEL (0xB8000208[14]) will use 4K2K or not */
	/*	when 4K2K must select the higher frequency */

	for (ilayer = 0; ilayer < data->layer_num; ilayer++) {

		/*	search the empty work space */
		for (idx = 0; idx < GDMA_MAX_PIC_Q_SIZE; idx++) {
			if (sGdmaReceiveWork[idx].used == 0) {
				sGdmaReceiveWork[idx].used = 1;
				break;
			}
		}
		emptyIdx = idx;
		DBG_PRINT("%s emptyIdx=%d\n", __FUNCTION__, emptyIdx);

		if (emptyIdx == GDMA_MAX_PIC_Q_SIZE) {
			printf("%s, Warning! GDMA workqueue is full \n", __FUNCTION__);
			return COMP_BUF_WORK_FULL;
		}

		com_picObj = &data->layer[ilayer];
		if (com_picObj->normal_num > 0)
			picObj = &com_picObj->normal[0];		/* just one normal OSD for one online path	*/
		else if (com_picObj->fbdc_num > 0)
			picObj = &com_picObj->fbdc[0];
		else
			printf("%s, PICTURE_LAYERS_OBJECT's COMPOSE_PICTURE_OBJECT has NO layer \n", __FUNCTION__);

		/*	in this function, one layer has only one picture in certain OSD HW */
		if (com_picObj->normal_num > 0 && com_picObj->fbdc_num > 0)
			printf("%s, PICTURE_LAYERS_OBJECT's COMPOSE_PICTURE_OBJECT layer has something wrong \n", __FUNCTION__);

		if (picObj->layer_used == 1) {
			if (picObj->plane == VO_GRAPHIC_OSD1)
				disPlane = GDMA_PLANE_OSD1;
			else if (picObj->plane == VO_GRAPHIC_OSD2)
				disPlane = GDMA_PLANE_OSD2;
			else if (picObj->plane == VO_GRAPHIC_OSD3)
				disPlane = GDMA_PLANE_OSD3;

			//onlinePlane[onlineMaxNum++] = disPlane;
			gdma->dispWin[disPlane].width = disp_res.width;
			gdma->dispWin[disPlane].height = disp_res.height;

			if (gdma->picQrd[disPlane] == ((gdma->picQwr[disPlane] + 1) & (GDMA_MAX_PIC_Q_SIZE - 1))) {
				printf( "GDMA: pic Queue %d fullness r %d,w %d\n", disPlane, gdma->picQrd[disPlane], gdma->picQwr[disPlane]);
				DBG_PRINT("GDMA: pic Queue %d fullness r %d,w %d\n", disPlane, gdma->picQrd[disPlane], gdma->picQwr[disPlane]);
				sGdmaReceiveWork[emptyIdx].used = 0;	/* free work */
				/* return -99; */
				continue;
			} else if (gdma->ctrl.zeroBuffer) {
				DBG_PRINT("GDMA: zeroBuffer is 1\n");
				sGdmaReceiveWork[emptyIdx].used = 0;	/* free work */
				return GDMA_SUCCESS;
			}
			DBG_PRINT("R\n");

			pic = gdma->pic[disPlane] + (idxQwr = (gdma->picQwr[disPlane] + 1) & (GDMA_MAX_PIC_Q_SIZE - 1));

			memset(pic, 0, sizeof(GDMA_PIC_DATA));

			pic->seg_num = picObj->seg_num;
			pic->cookie = data->cookie;
			pic->show = picObj->show;
			pic->syncInfo = picObj->syncInfo;
			pic->workqueueDone = 0;
			pic->onlineOrder = com_picObj->onlineOrder;

			pic->clear_x.value = picObj->clear_x.value;
			pic->clear_y.value = picObj->clear_y.value;
			*(char *)&pic->status = 0;
			pic->repeatCnt = 0;
			pic->context   = picObj->context;
			pic->workqueueIdx = emptyIdx;
			pic->scale_factor = picObj->scale_factor;

			/*  mixer's plane alpha setting, only for normal OSD */
			/*if (com_picObj->normal_num > 0) */{
				pic->plane_ar.value = picObj->plane_ar.value;
				pic->plane_gb.value = picObj->plane_gb.value;
			}

			win = &pic->OSDwin;
			win3D = &pic->OSDwin3D;

			win->nxtAddr.addr	  = 0;
			win->nxtAddr.last	  = 1;

			/* win->winXY.x 		 = (gdma->f_box_mode && gdma->box_dst_height == VIDEO_USERDEFINED)? picObj->x: picObj->dst_x; //picObj->dst_x; //picObj->x; */
			/* win->winXY.y 		 = (gdma->f_box_mode && gdma->box_dst_height == VIDEO_USERDEFINED)? picObj->y: picObj->dst_y; //picObj->dst_y; //picObj->y; */

			/*	canvas X, Y always set the X, Y from picture */
			/*	destination x, y, width, height are for final resolution and position on panel */
			win->winXY.x		  = picObj->x;
			win->winXY.y		  = picObj->y;

			win->winWH.width	  = picObj->width;
			win->winWH.height	  = picObj->height;
			win->attr.extendMode  = 0;
			win->attr.rgbOrder	  = picObj->rgb_order;/* VO_OSD_COLOR_RGB; */
			win->attr.objType	  = 0;
			win->attr.type		  = picObj->format & 0x1f;
			win->attr.littleEndian = picObj->format >> 5;
			win->attr.alphaEn	  = (win->attr.alpha   = picObj->alpha) >  0 ? 1 : 0;
			win->pitch			  = picObj->pitch;
			if (gdma->f_palette_update)
				win->attr.keepPreCLUT = 0;
			else
				win->attr.keepPreCLUT = 1;
			gdma->f_palette_update = false;
			win->attr.clut_fmt	  = picObj->paletteformat;/* rgba format */
			if (win->attr.type < 3)
				win->CLUT_addr = virt_to_phys(gdma->OSD_CLUT[picObj->paletteIndex]);

			win->objOffset.objXoffset = picObj->x;
			win->objOffset.objYoffset = gdma->ctrl.enableVFlip ? 0 : picObj->y;

			win->dst_x = picObj->dst_x;
			win->dst_y = picObj->dst_y;

			/*	destination width/height set as the panel resolution */
			if (picObj->dst_width == 0) 	/*	0 means scaling to panel resolution */
				win->dst_width = disp_res.width;
			else
				win->dst_width = picObj->dst_width;
			if (picObj->dst_height == 0)	/*	0 means scaling to panel resolution */
				win->dst_height = disp_res.height;
			else
				win->dst_height = picObj->dst_height;

			win->attr.compress = 0;
			win->used = 1;

			if (win->attr.compress) {
				win->colorKey.keyEn   = picObj->key_en;
				win->colorKey.key	  = picObj->colorkey;
			} else {
				win->colorKey.keyEn   = (picObj->colorkey != -1);
				win->colorKey.key	  = picObj->colorkey;
			}

			win->top_addr		  = picObj->address + (gdma->ctrl.enableVFlip ? picObj->y + picObj->height - 1 : 0) * picObj->pitch;

			/*	3D mode configuration */
			if (gdma->ctrl.enable3D) {
				/*	3d mode test */
				/* picObj->picLayout = INBAND_CMD_GRAPHIC_SIDE_BY_SIDE; */
				/* picObj->picLayout = INBAND_CMD_GRAPHIC_TOP_AND_BOTTOM; */

				/*	1: PR mode */
				if (gdma->ctrl.enable3D_PR_SGMode) {
					if (picObj->picLayout == INBAND_CMD_GRAPHIC_TOP_AND_BOTTOM) {
						printf("GDMA, %s, Not support top-bottom in PR mode \n", __FUNCTION__);
					} else if (picObj->picLayout == INBAND_CMD_GRAPHIC_SIDE_BY_SIDE) {
						win->winWH.width = picObj->width >> 1;
						win->pitch >>= 1;
						win->objOffset.objXoffset += win3D->winWH.width;
					}
				} else {	/*	0: SG mode */
					memcpy(win3D, win, sizeof(GDMA_WIN));

					if (picObj->picLayout == INBAND_CMD_GRAPHIC_TOP_AND_BOTTOM) {
						win3D->winWH.height = win->winWH.height = picObj->height >> 1;
						if (gdma->ctrl.enableVFlip)
							win3D->top_addr -= (win3D->winWH.height * win3D->pitch);
						else
							win->objOffset.objYoffset += win3D->winWH.height;
					} else if (picObj->picLayout == INBAND_CMD_GRAPHIC_SIDE_BY_SIDE) {
						win3D->winWH.width = win->winWH.width = picObj->width >> 1;
						win->objOffset.objXoffset += win3D->winWH.width;
						win3D->pitch = win->pitch;
					}
				}
			}

			win->fbdc_attr.pre_blend_c0_sel = 1;
			win->fbdc_attr.pre_blend_c1_sel = 2;
			win->fbdc_attr.pre_blend_c2_sel = 3;

			/*	TODO: FBDC information */
			win->attr.IMGcompress =  (com_picObj->fbdc_num > 0) ? 1 : 0;
			if (win->attr.IMGcompress) {
				win->attr.type = VO_OSD_COLOR_FORMAT_ARGB8888 & 0x1f;
				win->attr.littleEndian = VO_OSD_COLOR_FORMAT_ARGB8888 >> 5;
				win->attr.alphaEn = 0;		/* FBDC has alpha fucntion itself */
				win->attr.alpha = 0;		/* FBDC has alpha fucntion itself */
				win->CLUT_addr = 0;
				win->dst_x = win->dst_y = 0;
			}
			for (idx = 0; idx < com_picObj->fbdc_num; idx++) {
				picObj = &com_picObj->fbdc[idx];

				if (idx == 0) {     /*  FBDC1 */
					win->fbdc_attr.pre_blend_en = 1;    /*  enable pre_blend */
					win->fbdc1_addr = picObj->address + (gdma->ctrl.enableVFlip ? picObj->y + picObj->height - 1 : 0) * picObj->pitch;
					win->fbdc_attr.fbdc_1st_en = 1;
					win->fbdc_attr.const_a_1st = ((win->fbdc_attr.alpha_1st = picObj->alpha) > 0) ? 1 : 0;
					win->fbdc_attr.plane_alpha_c0 = (picObj->plane_ar.plane_alpha_a != 0xff || picObj->plane_ar.plane_alpha_r != 0xff ||
													 picObj->plane_gb.plane_alpha_g != 0xff || picObj->plane_gb.plane_alpha_b != 0xff) ? 1 : 0;
					win->fbdc_plane_alpha_c2.plane_alpha_a = (picObj->plane_ar.plane_alpha_a > 255) ? 255 : picObj->plane_ar.plane_alpha_a;
					win->fbdc_plane_alpha_c2.plane_alpha_r = (picObj->plane_ar.plane_alpha_r > 255) ? 255 : picObj->plane_ar.plane_alpha_r;
					win->fbdc_plane_alpha_c2.plane_alpha_g = (picObj->plane_gb.plane_alpha_g > 255) ? 255 : picObj->plane_gb.plane_alpha_g;
					win->fbdc_plane_alpha_c2.plane_alpha_b = (picObj->plane_gb.plane_alpha_b > 255) ? 255 : picObj->plane_gb.plane_alpha_b;
					/*win->fbdc_attr.pre_blend_c0_sel = 1;*/
					win->fbdc_format.fbdc_fmt_1st = picObj->fbdc_format;
					win->fbdc1_totaltile.x_total_tile = (picObj->width / 16);
					win->fbdc1_totaltile.y_total_tile = (picObj->height / 4);
					win->fbdc1_xy_pixel.x_pic_pixel = picObj->width;
					win->fbdc1_xy_pixel.y_pic_pixel = picObj->height;
					win->fbdc1_xy_sta.x_sta = picObj->x;
					win->fbdc1_xy_sta.y_sta = (gdma->ctrl.enableVFlip ? (picObj->height-1) : picObj->y);
					win->fbdc1_preblend_xy_sta.x_sta = picObj->dst_x/picObj->scale_factor;
					win->fbdc1_preblend_xy_sta.y_sta = picObj->dst_y/picObj->scale_factor;
				} else if (idx == 1) { /*  FBDC2 */
					win->fbdc2_addr = picObj->address + (gdma->ctrl.enableVFlip ? picObj->y + picObj->height - 1 : 0) * picObj->pitch;
					win->fbdc_attr.fbdc_2nd_en = 1;
					win->fbdc_attr.const_a_2nd = ((win->fbdc_attr.alpha_2nd = picObj->alpha) > 0) ? 1 : 0;
					win->fbdc_attr.plane_alpha_c1 = (picObj->plane_ar.plane_alpha_a != 0xff || picObj->plane_ar.plane_alpha_r != 0xff ||
													 picObj->plane_gb.plane_alpha_g != 0xff || picObj->plane_gb.plane_alpha_b != 0xff) ? 1 : 0;
					win->fbdc_plane_alpha_c1.plane_alpha_a = (picObj->plane_ar.plane_alpha_a > 255) ? 255 : picObj->plane_ar.plane_alpha_a;
					win->fbdc_plane_alpha_c1.plane_alpha_r = (picObj->plane_ar.plane_alpha_r > 255) ? 255 : picObj->plane_ar.plane_alpha_r;
					win->fbdc_plane_alpha_c1.plane_alpha_g = (picObj->plane_gb.plane_alpha_g > 255) ? 255 : picObj->plane_gb.plane_alpha_g;
					win->fbdc_plane_alpha_c1.plane_alpha_b = (picObj->plane_gb.plane_alpha_b > 255) ? 255 : picObj->plane_gb.plane_alpha_b;
					/*win->fbdc_attr.pre_blend_c1_sel = 2;*/
					win->fbdc_format.fbdc_fmt_2nd = picObj->fbdc_format;
					win->fbdc2_totaltile.x_total_tile = (picObj->width / 16);
					win->fbdc2_totaltile.y_total_tile = (picObj->height / 4);
					win->fbdc2_xy_pixel.x_pic_pixel = picObj->width;
					win->fbdc2_xy_pixel.y_pic_pixel = picObj->height;
					win->fbdc2_xy_sta.x_sta = picObj->x;
					win->fbdc2_xy_sta.y_sta = (gdma->ctrl.enableVFlip ? (picObj->height-1) : picObj->y);
					win->fbdc2_preblend_xy_sta.x_sta = picObj->dst_x/picObj->scale_factor;
					win->fbdc2_preblend_xy_sta.y_sta = picObj->dst_y/picObj->scale_factor;
				} else if (idx == 2) { /*  FBDC3 */
					win->fbdc3_addr = picObj->address + (gdma->ctrl.enableVFlip ? picObj->y + picObj->height - 1 : 0) * picObj->pitch;
					win->fbdc_attr.fbdc_3rd_en = 1;
					win->fbdc_attr.const_a_3rd = ((win->fbdc_format.alpha_3rd = picObj->alpha) > 0) ? 1 : 0;
					win->fbdc_attr.plane_alpha_c2 = (picObj->plane_ar.plane_alpha_a != 0xff || picObj->plane_ar.plane_alpha_r != 0xff ||
													 picObj->plane_gb.plane_alpha_g != 0xff || picObj->plane_gb.plane_alpha_b != 0xff) ? 1 : 0;
					win->fbdc_plane_alpha_c0.plane_alpha_a = (picObj->plane_ar.plane_alpha_a > 255) ? 255 : picObj->plane_ar.plane_alpha_a;
					win->fbdc_plane_alpha_c0.plane_alpha_r = (picObj->plane_ar.plane_alpha_r > 255) ? 255 : picObj->plane_ar.plane_alpha_r;
					win->fbdc_plane_alpha_c0.plane_alpha_g = (picObj->plane_gb.plane_alpha_g > 255) ? 255 : picObj->plane_gb.plane_alpha_g;
					win->fbdc_plane_alpha_c0.plane_alpha_b = (picObj->plane_gb.plane_alpha_b > 255) ? 255 : picObj->plane_gb.plane_alpha_b;
					/*win->fbdc_attr.pre_blend_c2_sel = 3;*/
					win->fbdc_format.fbdc_fmt_3rd = picObj->fbdc_format;
					win->fbdc3_totaltile.x_total_tile = (picObj->width / 16);
					win->fbdc3_totaltile.y_total_tile = (picObj->height / 4);
					win->fbdc3_xy_pixel.x_pic_pixel = picObj->width;
					win->fbdc3_xy_pixel.y_pic_pixel = picObj->height;
					win->fbdc3_xy_sta.x_sta = picObj->x;
					win->fbdc3_xy_sta.y_sta = (gdma->ctrl.enableVFlip ? (picObj->height-1) : picObj->y);
					win->fbdc3_preblend_xy_sta.x_sta = picObj->dst_x/picObj->scale_factor;
					win->fbdc3_preblend_xy_sta.y_sta = picObj->dst_y/picObj->scale_factor;
				}

				/* calculate the canvas size */
				win->winWH.width      = ((picObj->width+picObj->dst_x) > win->winWH.width) ? (picObj->width+picObj->dst_x) : win->winWH.width;
				win->winWH.height     = ((picObj->height+picObj->dst_y) > win->winWH.height) ? (picObj->height+picObj->dst_y) : win->winWH.height;
			}
			/*  k blend factor for FBDC */
			win->fbdc_blend1st.k1_blend = 0xc;
			win->fbdc_blend1st.k2_blend = 0x3;
			win->fbdc_blend1st.k3_blend = 0x2d;
			win->fbdc_blend1st.k4_blend = 0x3;
			win->fbdc_blend2nd.k1_blend = 0xc;
			win->fbdc_blend2nd.k2_blend = 0x3;
			win->fbdc_blend2nd.k3_blend = 0x2d;
			win->fbdc_blend2nd.k4_blend = 0x3;

			/* check OSD over panel resolution */
			/*
			printf(" [GDMA] picObj->dst_x=%d, picObj->dst_width=%d, picObj->width=%d ! \n ", picObj->dst_x, picObj->dst_width, picObj->width);
			printf(" [GDMA] picObj->dst_y=%d, picObj->dst_height=%d, picObj->height=%d ! \n ", picObj->dst_y, picObj->dst_height, picObj->height);
			*/
			if (((picObj->dst_x+picObj->dst_width) > disp_res.width)) {
				/* change image width in osd windows info.  */
				if (picObj->dst_width > picObj->width) {
					win->winWH.width = ((disp_res.width - picObj->dst_x) / (picObj->dst_width / picObj->width));
					if (win->winWH.width < 16)		/* OSD_SR input width size minimal 16 */
						win->winWH.width = 16;
					win->dst_width = picObj->dst_width = (win->winWH.width * (picObj->dst_width / picObj->width));
					if ((picObj->dst_x+picObj->dst_width) > disp_res.width)
						win->dst_x = picObj->dst_x = picObj->dst_x - ((picObj->dst_x+picObj->dst_width)-disp_res.width);
				} else if (picObj->dst_width <= win->winWH.width)
					win->winWH.width = win->dst_width = picObj->dst_width = disp_res.width - picObj->dst_x;

				/*printf("[GDMA]--> win->dst_x=%d, win->dst_width=%d, win->winWH.width=%d ! \n ", win->dst_x, win->dst_width, win->winWH.width);*/
			}
			if (((picObj->dst_y+picObj->dst_height) > disp_res.height)) {
				/* change image height in osd windows info.  */
				if (picObj->dst_height > picObj->height) {
					win->winWH.height = ((disp_res.height - picObj->dst_y) / (picObj->dst_height / picObj->height));
					if (win->winWH.height < 4)		/* OSD_SR input height size minimal 4 */
						win->winWH.height = 4;
					win->dst_height = picObj->dst_height = (win->winWH.height * (picObj->dst_height / picObj->height));
				} else if (picObj->dst_height <= win->winWH.height)
					win->winWH.height = win->dst_height = picObj->dst_height = disp_res.height - picObj->dst_y;
			}

			dsb();
			DBG_PRINT("%s, disPlane=%d win->attr.compress=%d \n", __FUNCTION__, disPlane, win->attr.compress);
			DBG_PRINT("%s, pic->seg_num = %d, pic->context = %d\n", __FUNCTION__, pic->seg_num, pic->context);
			DBG_PRINT("%s, win->winWH.width = %d, win->winWH.height= %d\n", __FUNCTION__, win->winWH.width, win->winWH.height);
			DBG_PRINT("%s, win->dst_width = %d, win->dst_height= %d\n", __FUNCTION__, win->dst_width, win->dst_height);
			DBG_PRINT("%s, win->pitch = %d,  win->attr.compress = %d\n", __FUNCTION__, win->pitch, win->attr.compress);
			DBG_PRINT("%s, win->top_addr = %x,  win->bot_addr = %x\n", __FUNCTION__, win->top_addr, win->bot_addr);
			DBG_PRINT("%s, pic->show = %d\n", __FUNCTION__, pic->show);
			DBG_PRINT("%s, pic->syncstamp = %lld\n", __FUNCTION__, pic->syncInfo.syncstamp);

			gdma->picCount[disPlane]++;
			gdma->picQwr[disPlane] = idxQwr;
			DBG_PRINT("%s, gdma->picQwr[%d]=%d \n", __FUNCTION__, disPlane, gdma->picQwr[disPlane]);

			/*	push work to workqueue */
			sGdmaReceiveWork[emptyIdx].disPlane = disPlane;
			sGdmaReceiveWork[emptyIdx].picQwr = idxQwr;
			//queue_work(psGdmaReceiveWorkQueue, &(sGdmaReceiveWork[emptyIdx].GdmaReceiveWork));

		} else
			printf("%s, No layer in use \n", __FUNCTION__);
	}

	DBG_PRINT("%s, layer loop done \n", __FUNCTION__);

	// data flush
	flush_dcache_all();

	// call GDMA_PreOSDReg_Set
	GDMA_PreOSDReg_Set(&sGdmaReceiveWork[emptyIdx]);

	// update GDMA picture
	GDMA_Update(gdma, 1) ;

	/*  work was done in workqueue */
	sGdmaReceiveWork[emptyIdx].used = 0;

	return GDMA_SUCCESS;
}


int GDMA_ConfigOSDEnable (bool flag)
{
	osdovl_mixer_ctrl2_RBUS mixer_ctrl2;
	/* disable OSD1/OSD2 on Mixer */
	*(volatile u32 *)&mixer_ctrl2 = rtd_inl(OSDOVL_Mixer_CTRL2_reg);
	mixer_ctrl2.mixer_en = flag;
	rtd_outl(OSDOVL_Mixer_CTRL2_reg, *(volatile u32 *)&mixer_ctrl2);

	/* disable OSD1/OSD2/OSD4 on OSD_CTRL */
	rtd_outl(GDMA_OSD1_CTRL_reg, GDMA_OSD1_CTRL_write_data(flag) | GDMA_OSD1_CTRL_osd1_en (1));
	rtd_outl(GDMA_OSD2_CTRL_reg, GDMA_OSD2_CTRL_write_data(flag) | GDMA_OSD2_CTRL_osd2_en (1));
	rtd_outl(GDMA_OSD3_CTRL_reg, GDMA_OSD3_CTRL_write_data(flag) | GDMA_OSD3_CTRL_osd3_en (1));
	DBG_PRINT("%s, %d, MIXER             0x%x\n", __FUNCTION__, __LINE__, rtd_inl(OSDOVL_Mixer_CTRL2_reg));
	return GDMA_SUCCESS;
}

int GDMA_ConfigOSDxEnable(GDMA_DISPLAY_PLANE disPlane, bool flag)
{
	unsigned int offset = 0;
	unsigned int progDone = GDMA_CTRL_write_data(1);
	gdma_dev *gdma = &gdma_devices[0];
	if (disPlane == GDMA_PLANE_OSD1) {
		offset = 0;
		progDone |= GDMA_CTRL_osd1_prog_done(1);
	} else if (disPlane == GDMA_PLANE_OSD2) {
		offset = 0x100;
		progDone |= GDMA_CTRL_osd2_prog_done(1);
	} else if (disPlane == GDMA_PLANE_OSD3) {
		offset = 0x200;
		progDone |= GDMA_CTRL_osd3_prog_done(1);
	}

	/* disable OSDx on OSD_CTRL */
	if (gdma) {
		gdma->ctrl.osdEn[disPlane] = flag;
	}

	/*	disable immediately */
	if (flag == false) {
		rtd_outl(GDMA_OSD1_CTRL_reg+offset, ~1);
		rtd_outl(GDMA_CTRL_reg, progDone);
	}
	return GDMA_SUCCESS;
}

#if 0
void drvif_color_OSD_Sharpness(DRV_OSD_sharp *ptr)
{
	osd_hpeaking_ctrl_1_RBUS	 osd_hpeaking_ctrl_1;
	osd_hpeaking_filter_1_RBUS	 osd_hpeaking_filter_1;
	osd_emf_ctrl_1_RBUS osd_emf_ctrl_1;
	osd_emf_extent_1_RBUS	osd_emf_extent_1;
	osd_hpeaking_gain_1_RBUS		osd_hpeaking_gain_1;
	osd_hpeaking_bound_1_RBUS	osd_hpeaking_bound_1;

	if (!ptr)
		return;

	osd_hpeaking_ctrl_1.osd_shpnr_en_ch1 = ptr->Osd_shpnr_en;
	osd_hpeaking_ctrl_1.peaking_enable_ch1 = ptr->peaking_en;
	osd_hpeaking_filter_1.c0_ch1 = ptr->C0;
	osd_hpeaking_filter_1.c1_ch1 = ptr->C1;
	osd_hpeaking_filter_1.c2_ch1 = ptr->C2;
	osd_emf_ctrl_1.emf_en_ch1 = ptr->EMF_en;
	osd_emf_ctrl_1.emf_range_ch1 = ptr->EMF_Range;
	osd_emf_ctrl_1.emf_shift_ch1 = ptr->EMF_Shift;
	osd_emf_ctrl_1.seg0_gain_sel_ch1 = ptr->Seg0_Gain_Sel;
	osd_emf_ctrl_1.seg0_offset_ch1 = ptr->Seg0_Offset;
	osd_emf_ctrl_1.seg1_gain_sel_ch1 = ptr->Seg1_Gain_Sel;
	osd_emf_ctrl_1.seg2_gain_sel_ch1 = ptr->Seg2_Gain_Sel;
	osd_emf_extent_1.emf_fixextent_ch1 = ptr->EMF_fixextent;
	osd_emf_extent_1.seg1_offset_ch1 = ptr->Seg1_Offset;
	osd_emf_extent_1.seg2_offset_ch1 = ptr->Seg2_Offset;
	osd_hpeaking_gain_1.gain_blr_ch1 = ptr->Gain_Blr;
	osd_hpeaking_gain_1.gain_neg_ch1 = ptr->Gain_Neg;
	osd_hpeaking_gain_1.gain_pos_ch1 = ptr->Gain_Pos;
	osd_hpeaking_bound_1.hv_neg_ch1 = ptr->HV_Neg;
	osd_hpeaking_bound_1.hv_pos_ch1 = ptr->HV_Pos;
	osd_hpeaking_bound_1.lv_ch1 = ptr->LV;

	rtd_outl(COLOR_OSD_SHPNR_OSD_HPEAKING_CTRL_1_VADDR, osd_hpeaking_ctrl_1.regValue);
	rtd_outl(COLOR_OSD_SHPNR_OSD_HPEAKING_FILTER_1_VADDR, osd_hpeaking_filter_1.regValue);
	rtd_outl(COLOR_OSD_SHPNR_OSD_EMF_CTRL_1_VADDR, osd_emf_ctrl_1.regValue);
	rtd_outl(COLOR_OSD_SHPNR_OSD_EMF_EXTENT_1_VADDR, osd_emf_extent_1.regValue);
	rtd_outl(COLOR_OSD_SHPNR_OSD_HPEAKING_GAIN_1_VADDR, osd_hpeaking_gain_1.regValue);
	rtd_outl(COLOR_OSD_SHPNR_OSD_HPEAKING_BOUND_1_VADDR, osd_hpeaking_bound_1.regValue);
}


void fwif_color_set_scaleosd_sharpness_driver(unsigned char src_index,unsigned char scale_factor)
{
	extern DRV_OSD_sharp gVipOSD_sharp[];
	drvif_color_OSD_Sharpness(&gVipOSD_sharp[scale_factor]);
}
#endif


void GDMA_Clk_Select(void)
{
	/* enable clken_disp_gdma & clken_disp_osd */
	rtd_outl(SYS_REG_SYS_DISPCLKSEL_reg, rtd_inl(SYS_REG_SYS_DISPCLKSEL_reg) |
		SYS_REG_SYS_DISPCLKSEL_clken_disp_gdma(1));

	/* pick higher freq. as GDMA clock source */
	//printf("[GDMA]BUSH = %d ; DISP = %d\n", GDMA_BusH_DClk_info(0), GDMA_BusH_DClk_info(1));
	printf("[GDMA](Frome bdinfo)BUSH = %d ; DISP = %d\n", get_bush(), get_disppll());

	if (get_bush() > get_disppll())
		rtd_outl(SYS_REG_SYS_DISPCLKSEL_reg, rtd_inl(SYS_REG_SYS_DISPCLKSEL_reg) & ~(1<<14));
	else
		rtd_outl(SYS_REG_SYS_DISPCLKSEL_reg, rtd_inl(SYS_REG_SYS_DISPCLKSEL_reg) | (1<<14));

}
