/*
 * cmd_rtk_pwm.c - interface to One-Time-Programmable memory
 *
 * Copyright (c) 2008-2015 Analog Devices Inc.
 *
 * Licensed under the GPL-2 or later.
 */

#include <common.h>
#include <command.h>
#include <drivers/pwm/pwm_menu.h>

int do_pwmtest(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    go_pwm_main_menu();
    return 0;
}

U_BOOT_CMD(
    pwm ,	6,	0,	do_pwmtest,
    "PWM command description/usage",
    ""
    );
