#ifndef __RTK_MD_HW_H__
#define __RTK_MD_HW_H__

/*MD error define*/
#define MD_SUCCESS      (0)
#define MD_ERR_WRITE_FAIL   (-1)
#define MD_ERR_NO_SEM       (-2)


extern void rtk_md_dump_reg(void);
extern void rtk_md_clk_on_off(int on_off);
extern void rtk_md_hw_init(void);
extern bool rtk_md_wait_hw_stopped(void);
extern int32_t rtk_md_write_cmd_wrapper(uint8_t *pbyCommandBuffer, uint32_t lCommandLength);
extern bool rtk_md_check_finish(uint16_t sw_cnt);
extern uint32_t rtk_md_do_hw_r_crc(uint32_t addrsrc, uint32_t len);
extern uint16_t rtk_md_get_issued_inst_count(void);

#endif /* _MD_H_ */
