#include <factorylib.h>
#include "cus_bootparam.h"

#define REG_MAGIC_51                               0xb8060110
#define REG_EMCU_RESET                             0xB8060034
#define REG_EMCU_CLKEN                             0xb8060044
#define SHARE_MEMORY_FOR_LED_STANDBY_TYPE          0xB8060570
//#define SHARE_MEMORY_FOR_LED_STANDBY_PARAM1        0xB8060574
#define BOOT_PARAM_FILE_NAME	FACTORY_HEADER_FILE_NAME"bin_panel/000BootParam.h"

extern uchar boot_ac_on;
extern int boot_power_on_mode;
extern int prev_power_on_status;

void StrToHex(char *pbDest, char *pbSrc, int nLen);
void HexToStr(char *pbDest, char *pbSrc, int nLen);
int check_ip(const char *ip);
int check_mac(const char *mac);